#include "templ3slot.h"
#include "tipos_.h"
#include "agenda_templ3slot.h"
#include <stdio.h>
#include <stdlib.h>

#define templ3s_inc  3
#define templ3s_cycles  1000000

/*-------------- INICIALIZACIN DE NOMBRES DE LISTAS ----------------*/



/*--------------------- FUNCIONES EXTERNAS --------------------*/

int templ3s_halt=FALSE;
char templ3s_estrategia=profundidad;
enum tipos_cambio{activacion=1, desactivacion};

/* Variables auxiliares para las partes izquierda de las reglas */
int LIz_templ3s_adds0=FALSE;
int LIz_templ3s_adds1=FALSE;
int LIz_templ3s_adds2=FALSE;
/*--------------- ESTRUCTURAS DE DATOS PARA LAS REGLAS ----------------*/

int templ3s_R1[1];     /* regla adds0 */ 

int templ3s_R2[1];     /* regla adds1 */ 

int templ3s_R3[1];     /* regla adds2 */ 

/*------------- ESTRUCTURAS DE DATOS PARA LAS CONDICIONES -------------*/

/* CONDICION: 0 REGLA: adds0*/ 

int activ_cond0_templ3s_adds0[1];
int camb_cond0_templ3s_adds0[1];
struct {
	int  tipo_cambio;
	int  instancias[1];
} cambios_cond0_templ3s_adds0[1];
int num_cambios_cond0_templ3s_adds0;

/* CONDICION: 0 REGLA: adds1*/ 

int activ_cond0_templ3s_adds1[1];
int camb_cond0_templ3s_adds1[1];
struct {
	int  tipo_cambio;
	int  instancias[1];
} cambios_cond0_templ3s_adds1[1];
int num_cambios_cond0_templ3s_adds1;

/* CONDICION: 0 REGLA: adds2*/ 

int activ_cond0_templ3s_adds2[1];
int camb_cond0_templ3s_adds2[1];
struct {
	int  tipo_cambio;
	int  instancias[1];
} cambios_cond0_templ3s_adds2[1];
int num_cambios_cond0_templ3s_adds2;


/*------------- FUNCIONES PARA LAS ESTRUCTURAS DE LAS REGLAS -------------*/

int templ3s_esta_activada(r)
	 templ3s_REGAGENDA r;
{
	switch (r.num_regla) {
		case 1:  return (templ3s_R1[r.instancias[0]]);
		case 2:  return (templ3s_R2[r.instancias[0]]);
		case 3:  return (templ3s_R3[r.instancias[0]]);
	}
}

void templ3s_marca_activada(r,entagen)
	 templ3s_REGAGENDA r;
	 int entagen;
{
	switch (r.num_regla) {
		case 1:  templ3s_R1[r.instancias[0]]=entagen;
			 break;
		case 2:  templ3s_R2[r.instancias[0]]=entagen;
			 break;
		case 3:  templ3s_R3[r.instancias[0]]=entagen;
			 break;
	}
}

int templ3s_marca_desactivada(r)
	 templ3s_REGAGENDA r;
{
	int entagen;

	switch (r.num_regla) {
		case 1:  entagen=templ3s_R1[r.instancias[0]];
			templ3s_R1[r.instancias[0]]=0;
			 break;
		case 2:  entagen=templ3s_R2[r.instancias[0]];
			templ3s_R2[r.instancias[0]]=0;
			 break;
		case 3:  entagen=templ3s_R3[r.instancias[0]];
			templ3s_R3[r.instancias[0]]=0;
			 break;
	}
	return(entagen);
}

void templ3s_elim_agenda(num_regla)
	 int num_regla;
{
	int iter[1];
	templ3s_REGAGENDA r;

	switch (num_regla) {
		case 1:  
		for(iter[0]=0;iter[0]<1; iter[0]++)
		 {
		     r.num_regla=1;
		     r.instancias[0]=iter[0];
			 if (templ3s_esta_activada(r)) templ3s_elimregla_agenda(r);
		 }
			 break;
		case 2:  
		for(iter[0]=0;iter[0]<1; iter[0]++)
		 {
		     r.num_regla=2;
		     r.instancias[0]=iter[0];
			 if (templ3s_esta_activada(r)) templ3s_elimregla_agenda(r);
		 }
			 break;
		case 3:  
		for(iter[0]=0;iter[0]<1; iter[0]++)
		 {
		     r.num_regla=3;
		     r.instancias[0]=iter[0];
			 if (templ3s_esta_activada(r)) templ3s_elimregla_agenda(r);
		 }
			 break;
	}
}

void templ3s_Inicializa_estructuras()
{
	int iter1;
/*** REGLA: adds0 ***/ 

	for(iter1=0;iter1<1; iter1++)
		templ3s_R1[iter1]=0;

  /* CONDICION: 0 REGLA: adds0 */ 

	for(iter1=0;iter1<1; iter1++)
		{  activ_cond0_templ3s_adds0[iter1]=CELDA_VACIA;
		   camb_cond0_templ3s_adds0[iter1]=CELDA_VACIA;}

	num_cambios_cond0_templ3s_adds0=0;

/*** REGLA: adds1 ***/ 

	for(iter1=0;iter1<1; iter1++)
		templ3s_R2[iter1]=0;

  /* CONDICION: 0 REGLA: adds1 */ 

	for(iter1=0;iter1<1; iter1++)
		{  activ_cond0_templ3s_adds1[iter1]=CELDA_VACIA;
		   camb_cond0_templ3s_adds1[iter1]=CELDA_VACIA;}

	num_cambios_cond0_templ3s_adds1=0;

/*** REGLA: adds2 ***/ 

	for(iter1=0;iter1<1; iter1++)
		templ3s_R3[iter1]=0;

  /* CONDICION: 0 REGLA: adds2 */ 

	for(iter1=0;iter1<1; iter1++)
		{  activ_cond0_templ3s_adds2[iter1]=CELDA_VACIA;
		   camb_cond0_templ3s_adds2[iter1]=CELDA_VACIA;}

	num_cambios_cond0_templ3s_adds2=0;

}

/*----------------- INICIALIZACION DE INSTANCIAS -------------------*/

void templ3s_Inicializa_instancias()
{
	/* inicializando instancia i1 */
	templ3s_i_templ[0].s0=0;
	templ3s_i_templ[0].s1=1;
	templ3s_i_templ[0].s2=2;
}

/*----------------- INICIALIZACION DE VARIABLES -------------------*/

void templ3s_Inicializa_variables()
{
}

/*--------------------- FUNCIONES INTERNAS --------------------*/

/*---------------------------  CONDICIONES -----------------------*/

/* CONDICION 0 adds0 */ 

void cond0_templ3s_adds0(vp)
	int vp;
{
	int lim_inf[1];
	int lim_sup[1];

	if (vp==-1) {
		lim_inf[0]=0;
		lim_sup[0]=1;
	} else {
		lim_inf[0]=vp;
		lim_sup[0]=vp+1;
	}
	for(vp=lim_inf[0]; vp<lim_sup[0];vp++) {
	if (templ3s_i_templ[vp].s0 < 1000000) {
		activ_cond0_templ3s_adds0[vp]=CELDA_OCUPADA;
		/* ahora se anotan los cambios */
		if (camb_cond0_templ3s_adds0[vp]!=activacion) {
			camb_cond0_templ3s_adds0[vp]=activacion;
			cambios_cond0_templ3s_adds0[num_cambios_cond0_templ3s_adds0].tipo_cambio=activacion;
			cambios_cond0_templ3s_adds0[num_cambios_cond0_templ3s_adds0].instancias[0]=vp;
			num_cambios_cond0_templ3s_adds0++;
		}
	} else {
		if (activ_cond0_templ3s_adds0[vp]!=CELDA_VACIA) {
			activ_cond0_templ3s_adds0[vp]=CELDA_VACIA;
			/* ahora se anotan los cambios */
			if (camb_cond0_templ3s_adds0[vp]!=desactivacion) {
				camb_cond0_templ3s_adds0[vp]=desactivacion;
				cambios_cond0_templ3s_adds0[num_cambios_cond0_templ3s_adds0].tipo_cambio=desactivacion;
				cambios_cond0_templ3s_adds0[num_cambios_cond0_templ3s_adds0].instancias[0]=vp;
				num_cambios_cond0_templ3s_adds0++;
			}
		}
	}
	}
}

/* CONDICION 0 adds1 */ 

void cond0_templ3s_adds1(vp)
	int vp;
{
	int lim_inf[1];
	int lim_sup[1];

	if (vp==-1) {
		lim_inf[0]=0;
		lim_sup[0]=1;
	} else {
		lim_inf[0]=vp;
		lim_sup[0]=vp+1;
	}
	for(vp=lim_inf[0]; vp<lim_sup[0];vp++) {
	if (templ3s_i_templ[vp].s1 < 1000000) {
		activ_cond0_templ3s_adds1[vp]=CELDA_OCUPADA;
		/* ahora se anotan los cambios */
		if (camb_cond0_templ3s_adds1[vp]!=activacion) {
			camb_cond0_templ3s_adds1[vp]=activacion;
			cambios_cond0_templ3s_adds1[num_cambios_cond0_templ3s_adds1].tipo_cambio=activacion;
			cambios_cond0_templ3s_adds1[num_cambios_cond0_templ3s_adds1].instancias[0]=vp;
			num_cambios_cond0_templ3s_adds1++;
		}
	} else {
		if (activ_cond0_templ3s_adds1[vp]!=CELDA_VACIA) {
			activ_cond0_templ3s_adds1[vp]=CELDA_VACIA;
			/* ahora se anotan los cambios */
			if (camb_cond0_templ3s_adds1[vp]!=desactivacion) {
				camb_cond0_templ3s_adds1[vp]=desactivacion;
				cambios_cond0_templ3s_adds1[num_cambios_cond0_templ3s_adds1].tipo_cambio=desactivacion;
				cambios_cond0_templ3s_adds1[num_cambios_cond0_templ3s_adds1].instancias[0]=vp;
				num_cambios_cond0_templ3s_adds1++;
			}
		}
	}
	}
}

/* CONDICION 0 adds2 */ 

void cond0_templ3s_adds2(vp)
	int vp;
{
	int lim_inf[1];
	int lim_sup[1];

	if (vp==-1) {
		lim_inf[0]=0;
		lim_sup[0]=1;
	} else {
		lim_inf[0]=vp;
		lim_sup[0]=vp+1;
	}
	for(vp=lim_inf[0]; vp<lim_sup[0];vp++) {
	if (templ3s_i_templ[vp].s2 < 1000000) {
		activ_cond0_templ3s_adds2[vp]=CELDA_OCUPADA;
		/* ahora se anotan los cambios */
		if (camb_cond0_templ3s_adds2[vp]!=activacion) {
			camb_cond0_templ3s_adds2[vp]=activacion;
			cambios_cond0_templ3s_adds2[num_cambios_cond0_templ3s_adds2].tipo_cambio=activacion;
			cambios_cond0_templ3s_adds2[num_cambios_cond0_templ3s_adds2].instancias[0]=vp;
			num_cambios_cond0_templ3s_adds2++;
		}
	} else {
		if (activ_cond0_templ3s_adds2[vp]!=CELDA_VACIA) {
			activ_cond0_templ3s_adds2[vp]=CELDA_VACIA;
			/* ahora se anotan los cambios */
			if (camb_cond0_templ3s_adds2[vp]!=desactivacion) {
				camb_cond0_templ3s_adds2[vp]=desactivacion;
				cambios_cond0_templ3s_adds2[num_cambios_cond0_templ3s_adds2].tipo_cambio=desactivacion;
				cambios_cond0_templ3s_adds2[num_cambios_cond0_templ3s_adds2].instancias[0]=vp;
				num_cambios_cond0_templ3s_adds2++;
			}
		}
	}
	}
}


/*--------------- PARTES IZQUIERDA DE LAS REGLAS ----------------*/
void Iz_templ3s_adds0()
{
	int ncamb;
	templ3s_REGAGENDA r;
	int  vp;

		if (num_cambios_cond0_templ3s_adds0>0) {
			ncamb=0;
			r.num_regla = 1;
			r.prioridad = 0;
			while (ncamb<num_cambios_cond0_templ3s_adds0) {
			    vp=cambios_cond0_templ3s_adds0[ncamb].instancias[0];
			    r.instancias[0]=vp;
			    camb_cond0_templ3s_adds0[vp]=CELDA_VACIA;
			    if (cambios_cond0_templ3s_adds0[ncamb].tipo_cambio==desactivacion) {
				if (templ3s_R1[vp]>0) {
					templ3s_elimregla_agenda(r);
				}
			    } else {  /* el cambio es una activacion */
				if (templ3s_R1[vp]==0) {
					templ3s_insregla_agenda(r);
				}
			    }
			    ncamb++;
			}
			num_cambios_cond0_templ3s_adds0=0;
		}
	LIz_templ3s_adds0=FALSE;
}

void Iz_templ3s_adds1()
{
	int ncamb;
	templ3s_REGAGENDA r;
	int  vp;

		if (num_cambios_cond0_templ3s_adds1>0) {
			ncamb=0;
			r.num_regla = 2;
			r.prioridad = 0;
			while (ncamb<num_cambios_cond0_templ3s_adds1) {
			    vp=cambios_cond0_templ3s_adds1[ncamb].instancias[0];
			    r.instancias[0]=vp;
			    camb_cond0_templ3s_adds1[vp]=CELDA_VACIA;
			    if (cambios_cond0_templ3s_adds1[ncamb].tipo_cambio==desactivacion) {
				if (templ3s_R2[vp]>0) {
					templ3s_elimregla_agenda(r);
				}
			    } else {  /* el cambio es una activacion */
				if (templ3s_R2[vp]==0) {
					templ3s_insregla_agenda(r);
				}
			    }
			    ncamb++;
			}
			num_cambios_cond0_templ3s_adds1=0;
		}
	LIz_templ3s_adds1=FALSE;
}

void Iz_templ3s_adds2()
{
	int ncamb;
	templ3s_REGAGENDA r;
	int  vp;

		if (num_cambios_cond0_templ3s_adds2>0) {
			ncamb=0;
			r.num_regla = 3;
			r.prioridad = 0;
			while (ncamb<num_cambios_cond0_templ3s_adds2) {
			    vp=cambios_cond0_templ3s_adds2[ncamb].instancias[0];
			    r.instancias[0]=vp;
			    camb_cond0_templ3s_adds2[vp]=CELDA_VACIA;
			    if (cambios_cond0_templ3s_adds2[ncamb].tipo_cambio==desactivacion) {
				if (templ3s_R3[vp]>0) {
					templ3s_elimregla_agenda(r);
				}
			    } else {  /* el cambio es una activacion */
				if (templ3s_R3[vp]==0) {
					templ3s_insregla_agenda(r);
				}
			    }
			    ncamb++;
			}
			num_cambios_cond0_templ3s_adds2=0;
		}
	LIz_templ3s_adds2=FALSE;
}

/*--------------- PARTES DERECHA DE LAS REGLAS ----------------*/
void De_templ3s_adds0(vp)
	int vp;
{
	int   cambio_asig[1];
	int   old_value_ent;
	float old_value_real;
	int   iter;

	for(iter=0;iter<1; iter++) cambio_asig[iter]=FALSE;

	old_value_ent=templ3s_i_templ[vp].s0;
	templ3s_i_templ[vp].s0=templ3s_i_templ[vp].s0+3;
	cambio_asig[0]=	old_value_ent != templ3s_i_templ[vp].s0;
	if (cambio_asig[0]) {
		cond0_templ3s_adds0(vp);
		LIz_templ3s_adds0=TRUE;
	}

	if (LIz_templ3s_adds0) Iz_templ3s_adds0();

}
void De_templ3s_adds1(vp)
	int vp;
{
	int   cambio_asig[1];
	int   old_value_ent;
	float old_value_real;
	int   iter;

	for(iter=0;iter<1; iter++) cambio_asig[iter]=FALSE;

	old_value_ent=templ3s_i_templ[vp].s1;
	templ3s_i_templ[vp].s1=templ3s_i_templ[vp].s1+3;
	cambio_asig[0]=	old_value_ent != templ3s_i_templ[vp].s1;
	if (cambio_asig[0]) {
		cond0_templ3s_adds1(vp);
		LIz_templ3s_adds1=TRUE;
	}

	if (LIz_templ3s_adds1) Iz_templ3s_adds1();

}
void De_templ3s_adds2(vp)
	int vp;
{
	int   cambio_asig[1];
	int   old_value_ent;
	float old_value_real;
	int   iter;

	for(iter=0;iter<1; iter++) cambio_asig[iter]=FALSE;

	old_value_ent=templ3s_i_templ[vp].s2;
	templ3s_i_templ[vp].s2=templ3s_i_templ[vp].s2+3;
	cambio_asig[0]=	old_value_ent != templ3s_i_templ[vp].s2;
	if (cambio_asig[0]) {
		cond0_templ3s_adds2(vp);
		LIz_templ3s_adds2=TRUE;
	}

	if (LIz_templ3s_adds2) Iz_templ3s_adds2();

}
/*----------------- FUNCION RESET -------------------*/
void templ3s_Reset()
{
	cond0_templ3s_adds0(0);
	cond0_templ3s_adds1(0);
	cond0_templ3s_adds2(0);
	Iz_templ3s_adds0();
	Iz_templ3s_adds1();
	Iz_templ3s_adds2();
}

void templ3s_Step()
{
	 templ3s_REGAGENDA r;

	r = templ3s_obten_regla_mas_prio();
	if (!templ3s_agenda_vacia) {
		templ3s_elimregla_agenda(r);
		switch (r.num_regla) {
			case 1:  De_templ3s_adds0(r.instancias[0]);
				 break;
			case 2:  De_templ3s_adds1(r.instancias[0]);
				 break;
			case 3:  De_templ3s_adds2(r.instancias[0]);
				 break;
		}
	}
}

void templ3slot(int templ3s_limit, int templ3s_steps) {
  int templ3s_paso = 0;
  int templ3s_iteracion = 0;
  int templ3s_long_cadena = 20;
  char templ3s_cadena[templ3s_long_cadena];
  templ3s_Inicializa_estructuras();
  templ3s_Inicializa_agenda();
  templ3s_Inicializa_instancias();
  templ3s_Inicializa_variables();
  templ3s_Reset();
  inicia_tiempo();
  while (!templ3s_agenda_vacia && !templ3s_halt) {
    if (templ3s_limit) {
      if (templ3s_iteracion == templ3s_limit) {
        exit(1);
      }
      else {
        templ3s_iteracion++;
      }
    }

    if (templ3s_steps) {
      if (templ3s_paso < templ3s_steps) {
        templ3s_paso++;
      }
      else {
        fprintf(stdout, "[q]uit, [Intro] or ####>");
        fgets(templ3s_cadena, templ3s_long_cadena, stdin);
        switch(templ3s_cadena[0]) {
        case 'q':
        case 'Q':
          exit(1);
          break;
        case '0': case '1': case '2': case '3': case '4':
        case '5': case '6': case '7': case '8': case '9':
          sscanf(templ3s_cadena, "%d", &templ3s_steps);
        default:
          templ3s_paso = 1;
          break;
        }
      }
    }
    templ3s_Step();
  }
  finaliza_tiempo();
}

int main(int argc, char *argv[]) {
  int templ3s_steps = 0;
  int templ3s_limit = 0;
  int i;

  for (i = 1; i < argc; i++) {
    if (!templ3s_limit && !strcmp(argv[i], "-limit")) {
      i++;
      templ3s_limit = atoi(argv[i]);
      if (templ3s_limit <= 0) {
        fprintf(stderr, "Uso incorrecto. Tras -limit se esperaba un entero positivo\n");
        exit(-1);
      }
    }
    else if (!templ3s_steps && !strcmp(argv[i], "-steps")) {
      i++;
      templ3s_steps = atoi(argv[i]);
      if (templ3s_steps <= 0) {
        fprintf(stderr, "Uso incorrecto. A -steps debe seguirle un valor entero positivo\n");
        exit(-1);
      }
    }
    else {
      fprintf(stderr, "%s %s\n", argv[0], argv[i]);
      fprintf(stderr, "Uso:\n");
      fprintf(stderr, "%s [-limit l] [-steps s]\n", argv[0]);
      fprintf(stderr, "-limit l establece en l el mximo nmero de reglas a disparadar.\n");
      fprintf(stderr, "-steps s establece en s el nmero de reglas a ejecutar antes de la sguiente pausa:\n");
      fprintf(stderr, "  Tras la ejecucin de s pasos el sistema de produccin espera:\n");
      fprintf(stderr, "  q fuerza la salida inmediata-\n");
      fprintf(stderr, "  un entero positivo sobreescribe el nmero de reglas a ejecutar entre pausas.\n");
      fprintf(stderr, "  cualquier otra tecla continua la ejecucin del sistema.\n");
      exit(-1);
    }
  }
  templ3slot(templ3s_limit, templ3s_steps);
  templ3slot(templ3s_limit, templ3s_steps);
  templ3slot(templ3s_limit, templ3s_steps);
}
