#include "mab.h"
#include <stdio.h>
#include <time.h>
#include "log_mab.h"


static char nombre_regla_3[] = "get_key_to_unlock";
static char nombre_regla_22[] = "walk_holding_nothing";
static char nombre_regla_8[] = "climb_ladder_to_hold";
static char nombre_regla_21[] = "get_on_floor_to_walk";
static char nombre_regla_26[] = "drop_to_climb";
static char nombre_regla_9[] = "grab_object_from_ladder";
static char nombre_regla_30[] = "hold_to_eat";
static char nombre_regla_23[] = "walk_holding_object";
static char nombre_regla_25[] = "walk_to_place_to_climb";
static char nombre_regla_31[] = "satisfy_hunger";
static char nombre_regla_4[] = "move_to_chest_with_key";
static char nombre_regla_14[] = "drop_object";
static char nombre_regla_27[] = "climb_indirectly";
static char nombre_regla_29[] = "already_on_object";
static char nombre_regla_16[] = "hold_object_to_move";
static char nombre_regla_18[] = "drop_object_once_moved";
static char nombre_regla_28[] = "climb_directly";
static char nombre_regla_6[] = "unlock_chest_to_hold_object";
static char nombre_regla_19[] = "already_moved_object";
static char nombre_regla_17[] = "move_object_to_place";
static char nombre_regla_20[] = "already_at_place";
static char nombre_regla_2[] = "put_chest_on_floor";
static char nombre_regla_1[] = "hold_chest_to_put_on_floor";
static char nombre_regla_24[] = "jump_onto_floor";
static char nombre_regla_5[] = "unlock_chest_with_key";
static char nombre_regla_11[] = "walk_to_hold";
static char nombre_regla_7[] = "use_ladder_to_hold";
static char nombre_regla_10[] = "climb_to_hold";
static char nombre_regla_13[] = "grab_object";
static char nombre_regla_15[] = "unlock_chest_to_move_object";
static char nombre_regla_12[] = "drop_to_hold";
static char *nombre_reglas[32];


static FILE *fd_log;
static char fmode_log[] = "w";


int mab_log_inicia_log() {
  if ((fd_log = fopen("mab.xml", fmode_log)) == NULL) {
    fprintf(stderr, "Cannot open log file mab.xml\n");
    fprintf(stderr, "mab aborted!\n");
    return 0;
  }
  //Se cambia el modo de apertura para permitir llamadas iterativas desde Artis
  fmode_log[0] = 'a';
  nombre_reglas[1] = nombre_regla_1;
  nombre_reglas[2] = nombre_regla_2;
  nombre_reglas[3] = nombre_regla_3;
  nombre_reglas[4] = nombre_regla_4;
  nombre_reglas[5] = nombre_regla_5;
  nombre_reglas[6] = nombre_regla_6;
  nombre_reglas[7] = nombre_regla_7;
  nombre_reglas[8] = nombre_regla_8;
  nombre_reglas[9] = nombre_regla_9;
  nombre_reglas[10] = nombre_regla_10;
  nombre_reglas[11] = nombre_regla_11;
  nombre_reglas[12] = nombre_regla_12;
  nombre_reglas[13] = nombre_regla_13;
  nombre_reglas[14] = nombre_regla_14;
  nombre_reglas[15] = nombre_regla_15;
  nombre_reglas[16] = nombre_regla_16;
  nombre_reglas[17] = nombre_regla_17;
  nombre_reglas[18] = nombre_regla_18;
  nombre_reglas[19] = nombre_regla_19;
  nombre_reglas[20] = nombre_regla_20;
  nombre_reglas[21] = nombre_regla_21;
  nombre_reglas[22] = nombre_regla_22;
  nombre_reglas[23] = nombre_regla_23;
  nombre_reglas[24] = nombre_regla_24;
  nombre_reglas[25] = nombre_regla_25;
  nombre_reglas[26] = nombre_regla_26;
  nombre_reglas[27] = nombre_regla_27;
  nombre_reglas[28] = nombre_regla_28;
  nombre_reglas[29] = nombre_regla_29;
  nombre_reglas[30] = nombre_regla_30;
  nombre_reglas[31] = nombre_regla_31;
  fprintf(fd_log, "<arlips_log RBS=\"mab\" timestamp=\"%f\">\n", ((double)clock())/CLOCKS_PER_SEC);
  return 1;
}


void mab_log_end_log(mab_kind_termination end) {
  char *message;
  switch (end) {
  case mab_elimit:
    message = "limit";
    break;
  case mab_equit:
    message = "quit";
    break;
  case mab_ehalt:
    message = "halt";
    break;
  case mab_eempty:
    message = "empty";
    break;
  }
  fprintf(fd_log, "  <end>%s</end>\n", message);
  fprintf(fd_log, "</arlips_log>\n\n");
  fclose(fd_log);
}


void mab_log_reset() {
  fprintf(fd_log, "  <reset>\n");
  fprintf(fd_log, "    <actions>\n");
}


void mab_log_end_reset() {
  mab_log_end_actions();
  fprintf(fd_log, "  </reset>\n");
}


void mab_log_regla_mas_prio(mab_REGAGENDA r) { 
  fprintf(fd_log, "  <fired>\n");
  fprintf(fd_log, "    <rule>%s</rule>\n", nombre_reglas[r.num_regla]);
  fprintf(fd_log, "    <priority>%d</priority>\n", r.prioridad);
  fprintf(fd_log, "    <actions>\n");
}


void mab_log_end_fire() {
  mab_log_end_actions();
  fprintf(fd_log, "  </fired>\n");
}


void mab_log_end_actions() {
  fprintf(fd_log, "    </actions>\n");
}


void mab_log_insregla(mab_REGAGENDA r) {
  fprintf(fd_log, "      <activation>\n");
  fprintf(fd_log, "        <rule>%s</rule>\n", nombre_reglas[r.num_regla]);
  fprintf(fd_log, "        <priority>%d</priority>\n", r.prioridad);
  fprintf(fd_log, "      </activation>\n");
}


void mab_log_elimregla(mab_REGAGENDA r) {
  fprintf(fd_log, "      <deactivation>\n");
  fprintf(fd_log, "        <rule>%s</rule>\n", nombre_reglas[r.num_regla]);
  fprintf(fd_log, "      </deactivation>\n");
}


void mab_log_facts() {
  fprintf(fd_log, "      <working_memory>\n");
  mab_log_class_chest();
  mab_log_class_thing();
  mab_log_class_monkey();
  mab_log_class_goal_is_to();
  fprintf(fd_log, "        <class id=\"system\">\n");
  fprintf(fd_log, "          <instances>\n");
  fprintf(fd_log, "          </instances>\n");
  fprintf(fd_log, "          <variables>\n");
  fprintf(fd_log, "            <var_aux>");
  fprintf(fd_log, "%d", mab_var_aux);
  fprintf(fd_log, "</var_aux>\n");
  fprintf(fd_log, "          </variables>\n");
  fprintf(fd_log, "        </class>\n");
  fprintf(fd_log, "      </working_memory>\n");
}

void mab_log_class_chest() {
  fprintf(fd_log, "        <class id=\"chest\">\n");
  fprintf(fd_log, "          <instances>\n");
  fprintf(fd_log, "            <i_chest_green_chest>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_chest[2].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <contents>");
  fprintf(fd_log, "%d", mab_i_chest[2].contents);
  fprintf(fd_log, "              </contents>\n");
  fprintf(fd_log, "              <unlocked_by>");
  fprintf(fd_log, "%d", mab_i_chest[2].unlocked_by);
  fprintf(fd_log, "              </unlocked_by>\n");
  fprintf(fd_log, "            </i_chest_green_chest>\n");
  fprintf(fd_log, "            <i_chest_red_chest>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_chest[0].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <contents>");
  fprintf(fd_log, "%d", mab_i_chest[0].contents);
  fprintf(fd_log, "              </contents>\n");
  fprintf(fd_log, "              <unlocked_by>");
  fprintf(fd_log, "%d", mab_i_chest[0].unlocked_by);
  fprintf(fd_log, "              </unlocked_by>\n");
  fprintf(fd_log, "            </i_chest_red_chest>\n");
  fprintf(fd_log, "            <i_chest_blue_chest>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_chest[1].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <contents>");
  fprintf(fd_log, "%d", mab_i_chest[1].contents);
  fprintf(fd_log, "              </contents>\n");
  fprintf(fd_log, "              <unlocked_by>");
  fprintf(fd_log, "%d", mab_i_chest[1].unlocked_by);
  fprintf(fd_log, "              </unlocked_by>\n");
  fprintf(fd_log, "            </i_chest_blue_chest>\n");
  fprintf(fd_log, "          </instances>\n");
  fprintf(fd_log, "          <variables>\n");
  fprintf(fd_log, "          </variables>\n");
  fprintf(fd_log, "        </class>\n");
}

void mab_log_class_thing() {
  fprintf(fd_log, "        <class id=\"thing\">\n");
  fprintf(fd_log, "          <instances>\n");
  fprintf(fd_log, "            <i_thing_green_couch>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[0].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[0].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[0].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[0].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[0].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_green_couch>\n");
  fprintf(fd_log, "            <i_thing_green_chest>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[7].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[7].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[7].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[7].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[7].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_green_chest>\n");
  fprintf(fd_log, "            <i_thing_red_couch>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[1].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[1].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[1].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[1].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[1].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_red_couch>\n");
  fprintf(fd_log, "            <i_thing_red_chest>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[3].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[3].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[3].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[3].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[3].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_red_chest>\n");
  fprintf(fd_log, "            <i_thing_inside_blue_chest>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[10].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[10].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[10].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[10].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[10].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_inside_blue_chest>\n");
  fprintf(fd_log, "            <i_thing_grapes>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[5].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[5].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[5].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[5].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[5].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_grapes>\n");
  fprintf(fd_log, "            <i_thing_red_key>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[8].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[8].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[8].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[8].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[8].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_red_key>\n");
  fprintf(fd_log, "            <i_thing_blue_couch>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[6].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[6].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[6].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[6].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[6].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_blue_couch>\n");
  fprintf(fd_log, "            <i_thing_inside_green_chest>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[11].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[11].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[11].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[11].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[11].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_inside_green_chest>\n");
  fprintf(fd_log, "            <i_thing_blue_chest>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[4].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[4].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[4].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[4].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[4].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_blue_chest>\n");
  fprintf(fd_log, "            <i_thing_inside_red_chest>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[9].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[9].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[9].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[9].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[9].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_inside_red_chest>\n");
  fprintf(fd_log, "            <i_thing_big_pillow>\n");
  fprintf(fd_log, "              <name>");
  fprintf(fd_log, "%d", mab_i_thing[2].name);
  fprintf(fd_log, "              </name>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_thing[2].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_thing[2].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <weight>");
  fprintf(fd_log, "%d", mab_i_thing[2].weight);
  fprintf(fd_log, "              </weight>\n");
  fprintf(fd_log, "              <inside_chest>");
  fprintf(fd_log, "%d", mab_i_thing[2].inside_chest);
  fprintf(fd_log, "              </inside_chest>\n");
  fprintf(fd_log, "            </i_thing_big_pillow>\n");
  fprintf(fd_log, "          </instances>\n");
  fprintf(fd_log, "          <variables>\n");
  fprintf(fd_log, "          </variables>\n");
  fprintf(fd_log, "        </class>\n");
}

void mab_log_class_monkey() {
  fprintf(fd_log, "        <class id=\"monkey\">\n");
  fprintf(fd_log, "          <instances>\n");
  fprintf(fd_log, "            <i_monkey>\n");
  fprintf(fd_log, "              <location>");
  fprintf(fd_log, "%d", mab_i_monkey[0].location);
  fprintf(fd_log, "              </location>\n");
  fprintf(fd_log, "              <on_top_of>");
  fprintf(fd_log, "%d", mab_i_monkey[0].on_top_of);
  fprintf(fd_log, "              </on_top_of>\n");
  fprintf(fd_log, "              <holding>");
  fprintf(fd_log, "%d", mab_i_monkey[0].holding);
  fprintf(fd_log, "              </holding>\n");
  fprintf(fd_log, "            </i_monkey>\n");
  fprintf(fd_log, "          </instances>\n");
  fprintf(fd_log, "          <variables>\n");
  fprintf(fd_log, "          </variables>\n");
  fprintf(fd_log, "        </class>\n");
}

void mab_log_class_goal_is_to() {
  fprintf(fd_log, "        <class id=\"goal_is_to\">\n");
  fprintf(fd_log, "          <instances>\n");
  fprintf(fd_log, "            <goal>\n");
  fprintf(fd_log, "              <action>");
  print_lent(fd_log, (LISTA_GENERICA_ENTEROS *)&mab_i_goal_is_to[0].action);
  fprintf(fd_log, "              </action>\n");
  fprintf(fd_log, "              <argument_1>");
  print_lent(fd_log, (LISTA_GENERICA_ENTEROS *)&mab_i_goal_is_to[0].argument_1);
  fprintf(fd_log, "              </argument_1>\n");
  fprintf(fd_log, "              <argument_2>");
  print_lent(fd_log, (LISTA_GENERICA_ENTEROS *)&mab_i_goal_is_to[0].argument_2);
  fprintf(fd_log, "              </argument_2>\n");
  fprintf(fd_log, "            </goal>\n");
  fprintf(fd_log, "          </instances>\n");
  fprintf(fd_log, "          <variables>\n");
  fprintf(fd_log, "          </variables>\n");
  fprintf(fd_log, "        </class>\n");
}

