/*

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Arlips compiler v. 3.1           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

File sinsem.c, syntactic-semantic analyzer
April 2006

Copyright (C) 2006 Emilio Vivancos Rubio

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                              Contact                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Author:              Emilio Vivancos Rubio  vivancos@dsic.upv.es
Developer Arlips v2: Mario Gonzlez Gimnez mgonzale@dsic.upv.es
Developer Arlips v3: Carlos Garca Montoro  cargarcia@dsic.upv.es

Departamento de Sistemas Informticos y Computacin
Universidad Politcnica de Valencia
Camino de Vera s/n
46022 Valencia
Spain

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


*/



//#define DEBUG 1 
#include "sinsem.h"
#include "errores.h"
#include "tds.h"

int numregla = 1;
int maxvp_der = 0;
int tam_lista_def = 255;
int estrategia = profundidad;
ENTREAL entreal_vacio;
int verbo;


REGFUNC * entfuncion;
REGREGLA * entregla;
int declarando_funcion = FALSE;
extern REGTDS * elemtds;
extern REGTIPO * elemtip;

/* int numinstancia = 1;
   int numpatvar = 1;  */

/***************************************************************************/
/*******  definicion de los conjuntos de PRIMEROS Y SIGUIENTES  ************/
/***************************************************************************/

/*************   PRIMEROS    **************/

char p_programa[]        ={abrepar, directiva, 0};
char p_decl_const[]      ={defconstsim,0};
char p_tipo[]            ={intesim, numero, realsim, mas, menos, charsim,
			   intlistsim, realistsim, booleansim, ident, arraysim, 0};
char p_decl_variables[]  ={defvariables,0};
char p_decl_classes[]    ={defclasesim,0};
char p_decl_subclasses[] ={isasim,nulo,0};
char p_decl_slots[]	 ={abrepar,nulo,0};
char p_decl_facetas[]	 ={cierrapar,0};
char p_f_type[]          ={abrepar,0};
char p_valor[]           ={mas,menos,abrepar,ident,numero,truesim,falsesim,0};
char p_f_defecto[]	 ={defaultsim,nulo,0};
char p_decl_pattern[]    ={defpatternsim,nulo,0};
char p_decl_instancias[] ={definstancesim,nulo,0};
char p_r_facts[]	 ={abrepar,nulo,0};
char p_lista_facts[]	 ={abrepar,nulo,0};
char p_decl_function[]	 ={deffunctionsim,nulo,0};
char p_decl_func_extr[]  ={externsim,nulo,0};
char p_param_form[]	 ={abrepar,nulo,0};
char p_decl_estrategia[] ={setstrategysim,0};
char p_an_pro[]		 ={depthsim,widthsim,0};
char p_lista_rules[]     ={defrulesim,nulo,0};
char p_prio[]            ={abrecor,nulo,0};
char p_llamada[]	 ={ident,0};
char p_param_act[]	 ={abrepar,nulo,0};
char p_condiciones[]     ={abrepar,nulo,0};
char p_condicion[]       ={mas, menos, existe, paratodo, numero, abrepar,
                           ident, headsim, tailsim,popheadsim,poptailsim,
                           oposim,opnosim,truesim,falsesim,sizesim,0};
char p_acciones[]        ={abrepar,nulo,0};
char p_expr[]            ={mas, menos, existe, paratodo, numero, abrepar,
                           ident, headsim, tailsim,popheadsim,poptailsim,
                           truesim,falsesim,sizesim,0};
char p_expr_sim[]        ={mas, menos, existe, paratodo, numero, abrepar,
                           ident, headsim, tailsim,popheadsim,poptailsim,
                           truesim,falsesim,sizesim,0};
char p_termino[]         ={existe, paratodo, numero, abrepar,ident, headsim,
                           tailsim,popheadsim,poptailsim,truesim,falsesim,sizesim,
                           0};
char p_factor[]          ={existe, paratodo, numero, abrepar,ident, headsim,
                           tailsim,popheadsim,poptailsim,truesim, falsesim,sizesim,
                           0};
char p_signo[]           ={mas,menos,nulo,0};
char p_accion[]          ={existe, ident, prinsim,returnsim,addheadsim,
                           addtailsim,haltsim, factssim, 0};
char p_lista_exp[]	 ={mas, menos, existe, paratodo, numero, abrepar,
                           ident, headsim, tailsim,popheadsim,poptailsim,cadenasim,
                           truesim,falsesim,sizesim,0};
char p_decl_tam[] 	 ={abrecor,nulo,0};


/*-------------------------------------------------------------------------*/

/**********  SIGUIENTES   **********/

char s_programa[]        ={dolar,0};
char s_decl_const[]      ={abrepar,0};
char s_tipo[]            ={cierrapar,abrepar,0};
char s_decl_variables[]  ={abrepar,0};
char s_decl_classes[]    ={abrepar,0};
char s_decl_subclasses[] ={abrepar,cierrapar,0};
char s_decl_slots[]	 ={cierrapar,0};
char s_decl_facetas[]	 ={cierrapar,0};
char s_f_clase[]	 ={abrepar,cierrapar,0};
char s_valor[]           ={cierrapar,0};
char s_f_defecto[]	 ={cierrapar,0};
char s_decl_pattern[]    ={abrepar,0};
char s_decl_instancias[] ={abrepar,0};
char s_r_facts[]	 ={cierrapar,0};
char s_lista_facts[]	 ={cierrapar,0};
char s_decl_function[]	 ={abrepar,0};
char s_decl_func_extr[]  ={abrepar,0};
char s_param_form[]	 ={dospunto,0};
char s_decl_estrategia[] ={abrepar,0};
char s_an_pro[]		 ={cierrapar,0};
char s_lista_rules[]     ={dolar,0};
char s_prio[]            ={abrepar,implisim,0};
char s_llamada[]	 ={cierracor,0};
char s_param_act[]	 ={cierracor,0};
char s_condiciones[]     ={implisim,0};
char s_condicion[]       ={cierrapar,0};
char s_acciones[]        ={cierrapar,0};
char s_expr[]            ={cierrapar,0};
char s_expr_sim[]        ={coma,igual,distinto,menorig,menor,mayorig,mayor,
			   cierrapar,cierracor,ident,mas,menos,paratodo,existe
			   ,numero,headsim, tailsim,popheadsim,poptailsim, opnosim,
                           abrepar,sizesim,0};
char s_termino[]         ={coma,igual,distinto,menorig,menor,mayorig,mayor,
			   cierrapar,cierracor,ident,mas,menos,paratodo,existe
			   ,numero,headsim, tailsim,popheadsim,poptailsim, opnosim,
                           sizesim,abrepar,0};
char s_factor[]          ={coma,igual,distinto,menorig,menor,mayorig,mayor,
			   cierrapar,cierracor,ident,mas,menos,paratodo,existe
			   ,numero,headsim, tailsim,popheadsim,poptailsim, opnosim,
                           abrepar,sizesim, opmult,opdiv,opysim,0};
char s_signo[]           ={existe,paratodo,numero,abrepar,opnosim,ident,
			   headsim,tailsim,popheadsim,poptailsim,sizesim,0};
char s_accion[]          ={cierrapar,0};
char s_lista_exp[]	 ={cierrapar,0};
char s_decl_tam[]	 ={cierrapar,abrepar,0};


/***************************************************************************/
/*******       prototipos de las funciones de la gramatica      ************/
/***************************************************************************/

void programa();
void decl_const();
void tipo();
void decl_variables();
void decl_classes();
void decl_subclasses();
void decl_slots();
void decl_facetas();
void f_type();
void valor();
void f_default();
void decl_instancias();
void decl_pattern();
void r_facts();
void lista_facts();
void decl_function();
void decl_function_externas();
void param_form();
void decl_estrategia();
void an_pro();
void lista_rules();
void prio();
void llamada();
void param_act();
void condiciones();
void condicion();
void acciones();
void expresion();
void expr_sim();
void termino();
void factor();
void signo();
void variable();
void accion();
void lista_exp();
void decl_tam();

/*************************************************************************/
/***********       ANALISIS  SINTACTICO  Y  SEMANTICO        *************/
/*************************************************************************/

void programa(tip,verb)
   char * tip;
   int verb;
{
  char error_=FALSE;
  char err_decl;

  verbo = verb;
  sincroniza(p_programa,22,s_programa);


  switch(simbolo) {
  case abrepar:
    do {
      empareja(abrepar,22,&error_);
      switch(simbolo) {
      case defconstsim: if (verbo) printf("Procesando constantes...\n");
	decl_const(&err_decl);
	break;
	
      case defvariables:if (verbo) printf("Procesando variables...\n");
	decl_variables(&err_decl);
	break;
      case defclasesim:
	decl_classes(&err_decl);
	break;
      case definstancesim: if (verbo) printf("Procesando instancias...\n");
	decl_instancias(&err_decl);
	break;
      case defpatternsim: if (verbo) printf("Procesando variables patron...\n");
	decl_pattern(&err_decl);
	break;
      case deffunctionsim: 
	decl_function(&err_decl);
	break;
      case setstrategysim: if (verbo) printf("Procesando estrategia...\n");
	decl_estrategia(&err_decl);
	break;
      case defrulesim: 
	lista_rules(&err_decl);
	break;
      case externsim:  
	decl_function_externas(&err_decl);
	break;
	/* se ha encontrado algo diferente despues de un '(' */
      default:
	menerror(113,&err_decl);
	err_decl = err;
      }
      if (err_decl==err) error_=TRUE;
    }while(simbolo==abrepar);
    break;
  }
  *tip = error_;
}


void decl_const(tip)
  char * tip;
{
 char error_=FALSE;
 ENTREAL n;
 char op;  /* para guardar el signo */
 LISTA * l;  /* lista de identificadores para las constantes */

 sincroniza(p_decl_const,30,s_decl_const);
 switch(simbolo){
  case defconstsim:
      	     obtsym();
	     do{
                empareja(abrepar,22,&error_);
	        empareja(ident,11,&error_);
                l=NULL;
                l=cr_lista_id(l,id);
                op=mas; /* por defecto */
                if(simbolo==mas || simbolo==menos) signo(&op);
                if(simbolo==numero && num<=MAXINT){
                    if(op==menos) num=num*(-1);
                    if (esreal) n.real=num;
                       else n.entero=num;
                    if (!busca_tipo_en_tds(id)) {
                        insertar_en_const(l,n,esreal);
                        if (verbo) printf("\tDeclarada constante: %s\n",id);
                    } else
                        menerror(70,&error_);
                }
	        empareja(numero,13,&error_);
	        empareja(cierrapar,21,&error_);
	     } while(simbolo==abrepar);
#ifdef DEBUG
             ver_tabla_tds();
#endif
             empareja(cierrapar,21,&error_);
 }
 if (error_) *tip = err;
    else *tip = vacio;
}

void tipo(//tip,linf,lsup,tam_lis, id_clase)
	  char * tip,
	  int  *linf,
	  int  *lsup,
	  int  *tam_lis,
	  char *id_clase,
	  int  *t_array) {
  char error_=FALSE;
  int a,b;
  char op;      /* aqui se indica el signo del numero */
  char tipoid;  /* tipo del identificador */
  REGTDS * idtds; /* entrada de la tabla de simbolos (si nos encontramos un identificador) */
  sincroniza(p_tipo,34,s_tipo);
  *id_clase = '\0';
  *tam_lis=0 ; /* EVR MAR05 */
  *t_array = vacio;

 switch(simbolo){
  case intesim:
	   empareja(intesim,33,&error_);
           *tip=entero;
	   break;
   case realsim:
	   empareja(realsim,33,&error_);
           *tip=real;
	   break;
   case charsim:
	   empareja(charsim,33,&error_);
           *tip=caracter;
	   break;
   case booleansim:
           empareja(booleansim,33,&error_);
           *tip=boolean;
           break;
   case numero:
	   /* tipo subrango, empezando sin signo */
	   if(!error_rango){
             *tip=subrango;
	     a=(int)num;
             *linf=a;
	     obtsym();
	     empareja(puntopunto,18,&error_);
	     op=mas; /* por defecto el numero es positivo */
	     if(simbolo==mas || simbolo==menos) signo(&op);
	     if(!error_rango){
                 if (simbolo==ident) /* otra constante? */
                     if (busca_tipo_en_tds(id)==constante) {
                        idtds=busca_en_tds(id);
                        if (idtds->tipo==entero) {
                            b=idtds->valor.entero;
		            if(op==menos) b=b*(-1); /* se le cambia el signo */
                            *lsup=b;
                            obtsym();
                        }
                        else {  /* no es entero */
                            /* error la constante debe ser entera */
                            menerror(94,&error_);
                            obtsym();
                            *tip=err;
                        }
                    }
                    else { /* el ident no es una constante */
                        /* se esperaba una constante entera */
                        menerror(94,&error_);
                        obtsym();
                        *tip=err;
                    }
                 else { /* no es un identificador: debe ser un numero */
                    b=(int)num;
		    if(op==menos) b=b*(-1); /* se le cambia el signo */
                    *lsup=b;
                    empareja(numero,13,&error_);
                 }
  		 if (a>b)
		 {
		   menerror(71,&error_);
                   *tip=err;
		   exit(-1);
		 }
	     }
	     else{  /* ha habido un error de rango, paso del numero */
               menerror(2,&error_);
	       obtsym();
               *tip=err;
	     }
	   }
	   else{/* ha habido un error de rango, paso del numero */
              menerror(2,&error_);
	      obtsym();
              *tip=err;
	   }
	   break;  

  case intlistsim: 
	   empareja(intlistsim,93,&error_);
           *tip=lista_enteros;
           if (simbolo==abrecor)
	     {  /* si se puede se procesa el tamao */
             obtsym();
             if (simbolo==numero)
	       {
               if (!esreal)
		 {
                 *tam_lis = (int) num;
		 }
	       else menerror(94,&error_);
               }
             empareja(numero,94,&error_);
	     empareja(cierracor,101,&error_);
           }
 	   else *tam_lis= 0;/* EVR MAR05 */
	   break;

   case realistsim:
	   empareja(realistsim,93,&error_);
           *tip=lista_reales;
           if (simbolo==abrecor) {  /* si se puede se procesa el tamao */
              obtsym();
              if (simbolo==numero) {
                if (!esreal) {
                  *tam_lis = (int) num;
                } else menerror(94,&error_);
              }
              empareja(numero,94,&error_);
              empareja(cierracor,101,&error_);
           }
 	   else *tam_lis= 0;/* EVR MAR05 */
	   break;

 case arraysim:
   *tip = array;
   obtsym();
   if (simbolo == abrecor) {
     obtsym();
     if (simbolo == numero && !esreal) {
       *tam_lis = (int)num;
     }
     else 
       menerror(94, &error_);
     empareja(numero, 125, &error_);
   }
   empareja(cierracor, 101, &error_);
   empareja(ofsim, 38, &error_);
   switch(simbolo) {
   case intesim:
     *t_array = entero;
     break;
   case realsim:
     *t_array = real;
     break;
   case boolean:
     *t_array = boolean;
     break;
   default:
     *t_array = err;
     menerror(126, &error_);
     break;
   }
   obtsym();
   break;
   
   
 case ident:
           tipoid=busca_tipo_en_tds(id);
	   obtsym();
           if (tipoid) {
             switch (tipoid) {
               case constante: idtds=busca_en_tds(id);       /* se trata de un subrango que */
                            if (idtds->tipo==entero) {    /* comienza con una constante  */
                             *tip=subrango;
                             a=idtds->valor.entero;
                             *linf=a;
	                     empareja(puntopunto,18,&error_);
	                     op=mas; /* por defecto el numero es positivo */
	                     if(simbolo==mas || simbolo==menos) signo(&op);
                             if (simbolo==ident) /* otra constante? */
                                 if (busca_tipo_en_tds(id)==constante) {
                                     idtds=busca_en_tds(id);
                                     if (idtds->tipo==entero) {
                                        b=idtds->valor.entero;
		                        if(op==menos) b=b*(-1); /* se le cambia el signo */
                                        *lsup=b;
                                        obtsym();
                                     }
                                     else {  /* no es entero */
                                        /* error la constante debe ser entera */
                                        menerror(94,&error_);
                                        obtsym();
                                        *tip=err;
                                     }
                                 }
                                 else { /* el ident no es una constante */
                                     /* se esperaba una constante */
                                     menerror(94,&error_);
                                     obtsym();
                                     *tip=err;
                             }
                             else { /* no es un identificador: debe ser un numero */
                                     b=(int)num;
		                     if(op==menos) b=b*(-1); /* se le cambia el signo */
                                     *lsup=b;
                                     empareja(numero,13,&error_);
                             }
                             if (a>b) {
		                 menerror(71,&error_);
                                 *tip=err;
		                 exit(-1);
		             }
                            }
                            else {
                              /* error la constante debe ser entera */
                              menerror(94,&error_);
                              *tip=err;
                            }
                            break;
              case clase:    /* si es una clase */
                            *tip = definido;
                            strcpy(id_clase, id);
                            break;

              default :       /* error se esperaba una clase (o una constante) */
                            menerror(27, &error_);
                            break;
             }
	   } else { /* no se ha encontrado el identificador */
               menerror(73, &error_);
               *tip=err;
           }
           break;


  default:
	 if(simbolo==mas || simbolo==menos){
	   /* tipo subrango, empezando con signo */
	   signo(&op);
	   if(!error_rango){
               *tip=subrango;
	       a=(int)num;
	       if(op==menos) a=a*(-1); /* se le cambia de signo */
               *linf=a;
	       obtsym();
	       empareja(puntopunto,18,&error_);
	       op=mas; /* por defecto el numero es positivo */
	       if(simbolo==mas || simbolo==menos) signo(&op);
	       if(!error_rango){
		  b=(int)num;
		  if(op==menos) b=b*(-1); /* se le cambia el signo */
                  *lsup=b;
		  empareja(numero,13,&error_);
		  if (a>b)
		   {
		     menerror(71,&error_);
                     *tip=err;
		     exit(-1);
		   }
	       }
	       else{ /* ha habido un error de rango, paso del num */
                    menerror(2,&error_);
		    obtsym();
                    *tip=err;
	       }
	   }
	   else{/* ha habido un error de rango, paso del numero */
             menerror(2,&error_);
	     obtsym();
             *tip=err;
	     }
	 }
  }
}

void decl_variables(char *tip) {

  char error_=FALSE;
  char nom_var[long_ident+1];
  LISTA *l;
  char tipo_var;
  int t_array;
  int linf;
  int lsup;
  ENTREAL defect;
  char tipo_def;
  LIS_NUM *lndef = NULL; 
  char inicializado;
  float temp;
  LISTA_NUM * lista_def;
  int tam_lista;
  char instancia_de[long_ident+1]; /* clase a la que pertenece si tipo=definido */
  REGTDS *enttds;
  int tam_lista_corchete = 0;
  int tam_lista_ini = 0;
 
  defect.entero=0; /* Por si no se le da un valor por defecto. EVR MAR05 */
  sincroniza(p_decl_variables,22,s_decl_variables);
  switch(simbolo){
  case defvariables:
    obtsym();
    do {
      inicializado = FALSE;
      empareja(abrepar,22,&error_);
      if (simbolo==ident) {
	strcpy(nom_var,id);
      }
      empareja(ident,11,&error_);
      
      f_type(&tipo_var, &linf, &lsup, &tam_lista_corchete, instancia_de, &t_array);

      
      if (simbolo==abrepar) { /* EVR MAR05 */
	obtsym(); /* EVR MAR05 */  
	f_default(&tipo_def,&defect,&lndef,&inicializado, &tam_lista_ini);


	if (tipo_var!=tipo_def && inicializado) {
	  /* si los tipos no coinciden */
	  /* error, el tipo del valor por defecto no coincide */
	  /* con el tipo declarado. Hay que tener en cuenta que esto */
	  /* no es exactamente asi, por ejemplo, si el slot es de tipo */
	  /* subrango, entonces el tipo devuelto por el valor por */
	  /* el valor asignado por defecto puede ser entero (aunque */
	  /* estar dentro del rango) */
	  if (tipo_var == subrango && tipo_def == entero) {
	    /* se comprueba que el valor esta dentro del rango correcto */
	    if (defect.entero<linf || defect.entero>lsup) 
	      menerror(71,&error_);
	  }
	  else
	    if (tipo_var==real && tipo_def==entero) {
	      /* se realiza la conversion de entero a real */
	      temp = (float) defect.entero;
	      defect.real = temp;
	    }
	    else 
	      if (tipo_var == array ) {
		if (tipo_def == lista_reales && t_array != real) {
		  menerror(3, &error_);
		}
	      }
	      else {
		if (tipo_var != lista_reales || tipo_def != lista_enteros) {
		  /* error de tipos mezclados */
		  menerror(3, &error_);
		}
	      }
	}
      } /* EVR MAR05 */
      
      
      if (!error_ && ((tipo_var==lista_enteros) || (tipo_var==lista_reales) || tipo_var == array)) {
	
	//Procesamos el tamao de la lista
	if (tam_lista_corchete) {
	  tam_lista = tam_lista_corchete;
	  if (tam_lista_ini > tam_lista_corchete)
	    menerror(123, &error_);
	}
	else 
	  if (tam_lista_ini)
	    tam_lista = tam_lista_ini;
	  else
	    tam_lista = tam_lista_def;
	

	lista_def=crea_lista_num(lista_def);
	lista_def->prim = lndef;
	
	
	if (lndef!=NULL) {
	  while(lndef->sig != NULL) {
	    lista_def->ult=lndef->sig;
	    lndef=lndef->sig;
	  }
	}
      }
      
      if (!error_) {
	if (tipo_var!=definido) {
	  enttds=instipsimple_entds(var,tipo_var,nom_var);
	  if (verbo) printf("\tDeclarada variable: %s\n",nom_var);
	  enttds->tbase_array = t_array;
	  enttds->inicializado = inicializado;
	  enttds->valor=defect;
	  enttds->tam_lista = tam_lista;
	  enttds->ld = lista_def;
	}
	else {
	  l=NULL;
	  l=cr_lista_id(l,nom_var);
	  enttds=instipdef_entds(var,instancia_de,l);
	}
      }
      empareja(cierrapar,21,&error_);
    } while(simbolo==abrepar);
    empareja(cierrapar,21,&error_);
    break;
  }
  if (error_) *tip = err;
  else *tip = vacio;
}

void decl_classes(tip)
  char  * tip;
{
char error_=FALSE;
LISTA * l;  /* lista de identificadores para las macro_var */
REGTIPO *t;
LISTA_CAMPOS *lc; /* lista para almacenar los slots de las clases */
int tama; /* tamano de los campos de cada clase */
char tip_subcl; /* recoge el posible error en las subclases */
char tip_slot;  /* recoge el posible error en los slots */

 sincroniza(p_decl_classes,32,s_decl_classes);
 switch(simbolo){
  case defclasesim:
            obtsym();
            l = NULL;
	    if (simbolo==ident) l=cr_lista_id(l,id,elemtds);;
	    /** Curiosa llamada a elemtds con tres parametros */
	    /** cuando solo tiene 2 en su declaracion         */
            empareja(ident,11,&error_);
	    decl_subclasses(&t,&tip_subcl);
            lc=NULL;
            decl_slots(&lc,&tip_slot);
            if (tip_subcl==err || tip_slot==err) error_=TRUE;
            if (!error_) { 
              instipdef_entipos(l,t,lc);
              if (verbo) printf("Declarada clase: %s\n",l->nombre);
            }
#ifdef DEBUG
            printf("inserto el tipo definido %s en clases\n",l->nombre);
            if (t!=NULL) printf("subclase de %s\n",t->nombre);
#endif
            l=borrar(l);
#ifdef DEBUG
            ver_tabla_tipos();
#endif
	    empareja(cierrapar,21,&error_);
 }
 if (error_) *tip = err;
    else *tip = vacio;
}


void decl_subclasses(t,tip)
     REGTIPO **t;
     char * tip;      /* sirve para saber si hay un error en la declaracion */
{
char error_=FALSE;

sincroniza(p_decl_subclasses,37,s_decl_subclasses);
 switch(simbolo){
  case isasim:
               obtsym();
               /* solo puede ser subclase de una clase ya definida */
               if(simbolo==ident) {
                   if(busca_tipo_en_tds(id)==clase) {
                     *t=busca_en_tipos(id);
                   }
                   else {
                     menerror(27,&error_);
                     *tip = err;
                     *t=NULL; /* error: clase no definida */
                   }
               }
		 else
               {
                   /* no es un identificador */
                   menerror(27,&error_);
                   *tip = err;
                   *t=NULL;
               }
	       empareja(ident,27,&error_);
               if (error_) *tip = err;
               break;
  default :    *tip=definido;
               *t=NULL;
 }
}             

void decl_slots(//lc,tip)
		LISTA_CAMPOS **lc,
		char * tip) {
  
  char error_=FALSE;
  LISTA *l;
  char tipo_slot;
  int t_array;
  int linf;
  int lsup;
  ENTREAL defect;
  char tipo_def;
  LIS_NUM *lndef;
  char inicializado;
  float temp;
  LISTA_NUM * lista_def;
  int tam_lista;
  int new_tam_lista =0; /* Num elementos en la inicializacion de la lista */
  char instancia_de[long_ident+1]; /* clase a la que pertenece si tipo=definido */
  int temposlot =0 ; /* Indica si el slot leido es estatico o temporal */
  char readstring[long_linea];
  char writestring[long_linea];
  float valor_cte ;
  
  
  sincroniza(p_decl_slots,22,s_decl_slots);
  switch(simbolo) {
  case abrepar:
    do {
      obtsym();
      if (simbolo == slotsim) { 
	temposlot =0 ; 
	obtsym();
      }
      else
	if (simbolo == temposlotsim) { 
	  temposlot =1 ; 
	  obtsym();
	}
	else
	  empareja(slotsim,42,&error_);
      empareja(ident,11,&error_);
      l=NULL;
      l=cr_lista_id(l,id);
#ifdef DEBUG
      printf("el slot de tipo %d es %s\n",temposlot, l->nombre);
#endif
      tam_lista = 0;
      lndef = NULL;
      f_type(&tipo_slot, &linf, &lsup, &tam_lista, instancia_de, &t_array);
      while(simbolo==abrepar){
	/* Se declaran el resto de slots */
	obtsym();
	switch(simbolo){
	case defaultsim:
	  f_default(&tipo_def,&defect,&lndef,&inicializado, &new_tam_lista);
	  if (tipo_slot!=tipo_def && inicializado)
	    /* si los tipos no coinciden error: */
	    /* El tipo del valor por defecto no coincide con el */
	    /* tipo declarado. Hay que tener en cuenta que esto */
	    /* no es exactamente asi, por ejemplo, si el slot es de tipo */
	    /* subrango, entonces el tipo devuelto por el valor por */
	    /* el valor asignado por defecto puede ser entero (aunque */
	    /* estar dentro del rango) */
	    if (tipo_slot==subrango && tipo_def==entero)
	      /* se comprueba que el valor esta dentro del rango correcto */
	      if (defect.entero<linf || defect.entero>lsup)
		menerror(71,&error_);
	      else
		if (tipo_slot==real && tipo_def==entero) {
		  /* se realiza la conversion de entero a real */
		  temp = (float) defect.entero;
		  defect.real = temp;
		} 
		else
		  menerror(3, &error_);   /* error de tipos mezclados */
	  break ;
	case accesorsim:
	  obtsym();
	  if (simbolo == readsim) {
	    obtsym();
	    printf("%",cadena_comillas);
	    strcpy(readstring, cadena_comillas);
	    empareja (cadenasim,110 ,&error_);
	  }
	  else
	    if (simbolo == writesim){
	      obtsym();
	      strcpy(writestring, cadena_comillas);
	      empareja (cadenasim,110 ,&error_);
	    }
	    else
	      menerror(115 ,&error_);
	  empareja (cierrapar, 21, &error_);
	  break;
	case nbvaluessim:
	  obtsym();
	  valor_cte = num ; /* Valor devuelto por el A.Lex */
	  empareja (numero, 13, &error_);
	  empareja (cierrapar, 21, &error_);
	  break ;
	case nbpredictsim:
	  obtsym();
	  valor_cte = num ; /* Valor devuelto por el A.Lex */
	  empareja (numero, 13, &error_);
	  empareja (cierrapar, 21, &error_);
	  break ;
	} /* Del switch */
      } /* Ya no quedan slots */
      
      if (!error_ && 
	  (tipo_slot==lista_enteros || tipo_slot==lista_reales || tipo_slot == array)) {
	/* si, a pesar de que es un tipo lista, no tiene un tamao, se le asigna uno por */
	/* defecto */
	if (tam_lista==0)
	  if (new_tam_lista == 0)
	    tam_lista=tam_lista_def;
	  else tam_lista = new_tam_lista;
	lista_def=crea_lista_num(lista_def);
	lista_def->prim = lndef;
	if (lndef!=NULL) {
	  while(lndef->sig!=NULL) {
	    lista_def->ult=lndef->sig;
	    lndef=lndef->sig;
	    /* tam_lista++; */
	  }
	}
      }
	
  
      //Comprobar que la declaracin y la inicializacin son compatibles
      //entendiendo por ello que la inicializacin no tiene ms elementos
      //que la declaracin
      if (!error_ && tipo_slot == array && tam_lista < new_tam_lista) {
	menerror(123, &error_);
      }

      
      //Comprobacin opcional: comprobar que las listas enteras no tienen reales:
      if (tipo_def == lista_reales &&
          (tipo_slot == lista_enteros || (tipo_slot == array && t_array == entero))) {
	menerror(3, &error_);
      }
      

      if (!error_)
	if (*lc==NULL) {
	  *lc=crea_lista_campos(*lc, l->nombre, tipo_slot, linf, lsup, defect, 
				lista_def, tam_lista, inicializado, instancia_de,
				t_array);
	  l=borrar(l);
	}
	else {
	  *lc=inserta_lista_campos(*lc, l , tipo_slot, linf, lsup, defect, lista_def,
				   tam_lista, inicializado, instancia_de, t_array);
	  l=borrar(l);
	}
      empareja(cierrapar,21,&error_);
    } while(simbolo==abrepar); /* No mas slots */
  }
  if (error_) *tip = err;
  else *tip = vacio;
}

void f_type(//tipo_slot,linf,lsup,tam_lis,id_clase)
	    char * tipo_slot,
	    int * linf,
	    int * lsup,
	    int * tam_lis,
	    char * id_clase,  
	    int *t_array) { //o equivalentemente char *t_array

  char error_=FALSE;

 sincroniza(p_f_type,22,s_f_clase);
 switch(simbolo){
  case abrepar:
            obtsym();
            empareja(typesim,65,&error_);
	    tipo(tipo_slot, linf, lsup, tam_lis, id_clase, t_array);
 	    empareja(cierrapar,21,&error_);
 }
}

void valor(
	   char *tip,
	   ENTREAL *val,
	   LIS_NUM **list,
	   int *num_ele_lista) { /* Numero de elementos si es una lista */


  char error_=FALSE;
  char op;          /* para guardar el signo */
  REGTDS * idtds;   /* entrada de la TDS para la constante */
  int nel = 0;   /* Var. local para el numero de elementos de la lista */
  
  sincroniza(p_valor,46,s_valor);
  op=mas; /* por defecto */
  (*list)=NULL;
  if (simbolo==mas || simbolo==menos) {
    signo(&op);
    if(simbolo==numero && num<=MAXINT){
      if(op==menos)
	num=num*(-1);
      if (esreal) {
	(*val).real=num;
	(*tip)=real;
      }
      else {
	(*val).entero=num;
	(*tip)=entero;
      }
    }
    empareja(numero,13,&error_);
  } 
  else
    if (simbolo==ident) {             /* es una constante */
      if (busca_tipo_en_tds(id)==constante) {
	idtds=busca_en_tds(id);
	(*val)=idtds->valor;
	(*tip)=idtds->tipo;
	obtsym();
      }
      else {
	/* un identificador que no es una constante */
	/* puede que ni siquiera este en la TDS */
	menerror(94,&error_);
      }
    }
    else
      if (simbolo==numero) {     /* es un numero */
	if (esreal) {
	  (*val).real=num;
	  (*tip)=real;
	}
	else {
	  (*val).entero=num;   /* FALTA ??? convertir a entero */
	  (*tip)=entero;
	}
	empareja(numero,13,&error_);
      }
      else
	if (simbolo==abrepar) {   /* es una lista */
	  obtsym();
	  (*tip) = lista_enteros;
	  do {
	    if (simbolo==mas || simbolo==menos) 
	      signo(&op);
	    else 
	      op = mas;

	    switch (simbolo) {
	    case ident:
	      if (busca_tipo_en_tds(id) == constante) {
		idtds = busca_en_tds(id);
		//(*val) = idtds->valor;
		switch (idtds->tipo) {
		case entero:
		  (*val).real = idtds->valor.entero;
		  break;
		case real:
		  (*val).real = idtds->valor.real;
		  (*tip) = lista_reales;
		  break;
		}
		if (op == menos) 
		  (*val).real = (*val).real * (-1);
		if ((*list) == NULL)
		  (*list) = crea_ln((*list), (*val));
		else
		  (*list) = inserta_ln((*list), (*val));
		obtsym();
	      }
	      else 
		empareja(numero,13,&error_);
	      break;
	    	    
	    case numero:
	      if (num<=MAXINT) {
		if (op==menos)
		  num=num*(-1);
		if (esreal) {
		  (*tip) = lista_reales; /* si hay algun numero real */
		  /* la lista es de numeros reales */
		}
		//Independientemente de si el nmero es entero o real,
		//se almacena como real, y luego se podr recuperar adecuadamente.
		(*val).real = num;
		if ((*list)==NULL)
		  (*list)=crea_ln((*list),(*val));
		else
		  (*list)=inserta_ln((*list),(*val));
	      }
	      //No hay break, hay que emparejar en ambos casos
	    default:
	      empareja(numero,13,&error_);
	    }
	    nel++; 
	  } while (simbolo!=cierrapar);
	  empareja(cierrapar,21,&error_);
	} 
	else
	  if (simbolo==truesim) {
	    (*val).entero=1;
	    (*tip)=boolean;
	    obtsym();
	  } 
	  else
	    if (simbolo==falsesim) {
	      (*val).entero=0;
	      (*tip)=boolean;
	      obtsym();
	      
	    }

  if (error_)
    *tip = err;
  *num_ele_lista = nel;
}

void f_default(tip,val,list,inicial,num_ele_lista)
     char *tip;
     ENTREAL *val;
     LIS_NUM **list;
     char *inicial; /* indica si esta inicializado con un valor por defecto */
     int *num_ele_lista;  /* Num. elementos en la inicializacion de una lista */
{
  char error_=FALSE;
  
  sincroniza(p_f_defecto,22,s_f_defecto);
  *inicial=FALSE;
  switch(simbolo){
  case defaultsim:
    obtsym();
    valor(tip, val, list, num_ele_lista);
    *inicial=TRUE;
    empareja(cierrapar,21,&error_);
  }
}

void decl_pattern(tip)
 char * tip;
{
char error_=FALSE;
int i;
LISTA * l;

 sincroniza(p_decl_pattern,28,s_decl_pattern);
 switch(simbolo){
  case defpatternsim:
	     obtsym();
	     do{
             empareja(abrepar,22,&error_);
             /* el patron no debe existir en la tds */
             if (simbolo==ident)
               if (busca_tipo_en_tds(id)) /* si ya existe en la TDS */
               {
                   /* error, este identificador ya existe */
                   menerror(70, &error_);
               }
               else {
                   l=NULL;
                   l=cr_lista_id(l,id);
               }
	     empareja(ident,11,&error_);

             if (simbolo==ident)
                if (busca_tipo_en_tds(id)==clase) {/* debe ser una clase */
                    instipdef_entds(paternvar,id,l);
                    if (verbo) printf("\tDeclarada variable patron: %s\n",l->nombre);
                } else {
                    /* error, se esperaba una clase */
                    menerror(27,&error_);
                }
	     empareja(ident,27,&error_);
	     empareja(cierrapar,21,&error_);
	     }while(simbolo==abrepar);
#ifdef DEBUG
             ver_tabla_tds();
#endif
             empareja(cierrapar,21,&error_);
 }
 if (error_) *tip = err;
    else *tip = vacio;

}

void decl_instancias(tip)
 char * tip;
{
char error_=FALSE;

 sincroniza(p_decl_instancias,35,s_decl_instancias);
 switch(simbolo){
  case definstancesim:
            obtsym();
            empareja(ident,11,&error_);
            /* que se debe hacer con el identificador que aparece en la */
            /* declaracion de instancias, sirve de algo? */
            r_facts(tip);
            empareja(cierrapar,21,&error_);
#ifdef DEBUG
            ver_tabla_tds();
#endif
 }
}


void r_facts(char *tip) {
  char error_=FALSE;
  char op;  /* guarda el signo */
  
  int tam;
  int a,b;
  int valorentero;
  LISTA *l;
  REGTDS *entins;   /* entrada de la instancia en la TDS */
  ENTREAL val;
  LIS_NUM * list_num;
  char tip_lfacts;
  char tip_val;
  char tip_decl;
  float temp;
  int nel = 0; 
  int tam_lista_corchete = 0;
  int tbase_array = vacio;
  
  sincroniza(p_r_facts,22,s_r_facts);
  do {
    empareja(abrepar,22,&error_);
    if (simbolo==ident) {
      l = NULL;
      l = cr_lista_id(l,id);
    }
    empareja(ident,11,&error_);
    empareja(ofsim,83,&error_);
    /* el identificador debe ser una clase definida */
    if (simbolo==ident) {
      if (busca_tipo_en_tds(id)==clase) {
	/* el simbolo ident no debe estar en la tds, esto
	   se comprueba en instipdef_entds */
	entins=instipdef_entds(instancia,id,l);
	if (verbo) printf("\tDeclarada instancia: %s\n",l->nombre);
#ifdef DEBUG
	ver_tabla_tds();
#endif
      }
      else {
	/* error, no es una clase */
	menerror(27,&error_);
      }
      empareja(ident,11,&error_);
      lista_facts(entins,&tip_lfacts);
      if (tip_lfacts==err) error_=TRUE;
    }
    else {
      if (tip_decl=es_tipo_simple(simbolo)) {

	obtsym();
	if((simbolo==numero)||(simbolo==ident)||(simbolo==abrepar)||
	   (simbolo==mas)||(simbolo==menos)||(simbolo==truesim)||
	   (simbolo==falsesim)) {

	  valor(&tip_val,&val,&list_num,&nel);
	  if (tip_val!=err) {
            if (tip_decl!=tip_val)  {     /* si los tipos no coinciden */
	      /* error, el tipo del valor por defecto no coincide */
	      /* con el tipo declarado. */
	      if (tip_decl==real && tip_val==entero) {
		/* se realiza la conversion de entero a real */
		temp = (float) val.entero;
		val.real = temp;
	      } 
	      else {
		/* error de tipos mezclados */
		menerror(3, &error_);
	      }
            }
	    if (verbo) printf("\tDeclarada instancia: %s\n",l->nombre);
	    entins=instipsimple_entds(instancia,tip_decl,l->nombre);
	    entins->inicializado = TRUE;
	    entins->valor=val;
	    entins->tipo=tip_decl;
	    entins->ld=crea_lista_num(entins->ld);
	    entins->ld->prim = list_num;
	    entins->tam_lista = 0;
	    if (list_num!=NULL) {
	      entins->tam_lista++;
	      while(list_num->sig!=NULL) {
		entins->ld->ult=list_num->sig;
		list_num=list_num->sig;
		entins->tam_lista++;
	      }
	    }
	  } 
	  else error_=TRUE;
	} 
	else { 
	  /* O no esta inicializado */
	  // O se trata de listas con tamao definido
	  //O desde el 13 Oct 2005 un array
	  if (simbolo == abrecor) {
	    obtsym();
	    if (simbolo == numero) {
	      if (!esreal) {
		tam_lista_corchete = (int) num;
	      }
	      else menerror(94,&error_);
	    }
	    empareja(numero,94,&error_);
	    empareja(cierracor,101,&error_);
	  }

	  if (tip_decl == array) {
	    empareja(ofsim, 83, &error_);
	    tbase_array = es_tipo_simple(simbolo);
	    if (tbase_array != entero && tbase_array != real && tbase_array != boolean)
	      menerror(126, &error_);
	    obtsym();
	  }

	  if (simbolo == abrepar) {
	    //La lista est inicializada...
	    valor(&tip_val, &val, &list_num, &nel);
	    if (tip_val != err) {
	      if (tip_decl != tip_val) { 
		if (tip_decl == array) {
		  if (tip_val == lista_reales && tbase_array != real) {
		    menerror(3, &error_);
		  } //inicializaste un vector de reales, pero declaraste otra cosa
		} //si se ha declarado un vector
		else {
		  if (!(tip_val == lista_enteros && tip_decl == lista_reales)) {
		    menerror(3, &error_);
		  } //La nica compatibilidad permitida es cuan inicializas una lista de reales con valores enteros
		} //else (no es array y por tanto, se trato de un vector)
	      } //Si el tipo de la declaracin y el de la inicializacin no coinciden.
	      if (verbo) printf("\tDeclarada instancia: %s\n",l->nombre);
	      entins = instipsimple_entds(instancia,tip_decl,l->nombre);
	      entins->inicializado = TRUE;
	      entins->valor = val;
	      entins->tipo = tip_decl;
	      entins->tbase_array = tbase_array;
	      entins->ld = crea_lista_num(entins->ld);
	      entins->ld->prim = list_num;
	      entins->tam_lista = tam_lista_corchete;
	      if (list_num!=NULL) {	       
		//list_num es una lista que contiene a todas las listas de nmeros
		//en una secuencia. Con lo que el tamao que se obtenga al recorrerla
		//no es el tamao de la lista que se est procesando, sino el cmulo
		//de todas las procesadas
		while(list_num->sig!=NULL) {
		  entins->ld->ult = list_num->sig;
		  list_num = list_num->sig;
		}
		if ((tam_lista_corchete) && (nel > tam_lista_corchete)) { 
		  menerror(123, &error_);
		}
	      }
	    }
	    else error_ = TRUE;
	  }
	      
	  if ((simbolo == cierrapar) && (nel == 0)) {
	    //Si la lista no se ha inicializado...
	    if (verbo)
	      printf("\tDeclarada instancia: %s\n",l->nombre);
	    entins=instipsimple_entds(instancia,tip_decl,l->nombre);
	    entins->inicializado = FALSE;
	    entins->tipo=tip_decl;
	    entins->tbase_array = tbase_array;
	    entins->ld=NULL;
	    if (tam_lista_corchete) 
	      entins->tam_lista = tam_lista_corchete;
	    else
	      entins->tam_lista = tam_lista_def;
	  }
	  else { 
	    /* deberia haber un parentesis cerrado si no esta inicializado */
	  }
	}
      } 
      else {  /* no hay ningun indicador de tipo simple */
	menerror(33,&error_);
      }
    }
    empareja(cierrapar,21,&error_);
  } while(simbolo==abrepar);
  if (error_) *tip=err;
  else *tip = vacio;
}

void lista_facts(//ptrotds,tip)
		 REGTDS * ptrotds,  /* puntero a la entrada TDS */
		 char * tip) {

  char error_=FALSE;
  char op;              /* guarda el signo del numero */
  LISTA_CAMPOS * campo; /* campo al que se esta accediendo */
  char tip_val;
  ENTREAL val;
  LIS_NUM * list_num;
  float temp;
  int nel; /*para la llamada a valor().  EVR MAR05 */ 
  int tam_lista_ini = 0;
  int posprocesa_valor; //Indica si tras la comprobacin de compatibilidad de tipos, se debe procesar el valor
  
  sincroniza(p_lista_facts,22,s_lista_facts);
  switch(simbolo){
  case abrepar:
    do{
      posprocesa_valor = 0;
      tam_lista_ini = 0;
      empareja(abrepar,22,&error_);
      if (simbolo==ident)
	if ((campo=busca_campo(id,ptrotds->lc))==NULL) {
	  /* error, ese identificador no es un campo */
	  menerror(96,&error_);
	}
      empareja(ident,11,&error_);
      valor(&tip_val,&val,&list_num, &nel);
      if (tip_val==err)
	error_= TRUE;
      if (tip_val!=campo->tipo && !error_) {
	if (campo->tipo==subrango && tip_val==entero) {
	  /* se comprueba que el valor esta dentro del rango correcto */
	  if (val.entero<campo->lim_inf || val.entero>campo->lim_sup)
	    menerror(71,&error_);
	  else {
	    campo->valor= val;
	    campo->inicializado = TRUE;
	  }
	}
	else
	  if (campo->tipo==real && tip_val==entero) {
	    /* se realiza la conversion de entero a real */
	    temp = (float) val.entero;
	    val.real = temp;
	    campo->valor=val;
	    campo->inicializado = TRUE;
	  }
	  else {
	    if (campo->tipo == array) {
	      if (tip_val == lista_reales && campo->tbase_array != real) {
		menerror(3, &error_);
	      }
	      else {
		posprocesa_valor = 1;
	      }
	    }
	    else { 
	      if (tip_val == lista_enteros && campo->tipo == lista_reales) {
		posprocesa_valor = 1;
	      }
	      else {
		/* error de tipos, el tipo del valor es dif */
		/* del tipo del valor que se intenta asignar */
		menerror(3, &error_);
	      }
	    }
	  }
      }
      else {
	posprocesa_valor = 1;
      }
      if (posprocesa_valor) {
	campo->valor = val;
	campo->inicializado = TRUE;
	if (tip_val==lista_enteros || tip_val==lista_reales || tip_val == array) {
	  campo->ld=crea_lista_num(campo->ld);
	  campo->ld->prim = list_num;
	  if (list_num!=NULL) {
	    tam_lista_ini++;
	    while(list_num->sig!=NULL) {
	      campo->ld->ult=list_num->sig;
	      list_num=list_num->sig;
	      tam_lista_ini++;
	    }
	    if (tam_lista_ini > campo->tam_lista)
	      menerror(123, &error_);
	  }
	  
	}
	/* FALTA: las listas */
	//Creo que ya no
      }
      empareja(cierrapar,21,&error_);
    } while(simbolo==abrepar);
  }
  if (error_) *tip = err;
  else     *tip =vacio;
}


/* FALTA: las variables de entrada */
void input()
{
 char error_=FALSE;

/* sincroniza(p_input,44,s_input);*/
 if(simbolo==inputsim){
    obtsym();
    /*lista_id(&l);*/
    empareja(puncom,10,&error_);
 }
}

void decl_function(tip)
   char *tip;
{
char error_=FALSE;
char nom_funcion[long_ident+1];
char tipo_dev;
LISTA_PARAM * lp;
char tip_param_form;
char tip_acciones;

 sincroniza(p_decl_function,31,s_decl_function);
 switch(simbolo){
   case deffunctionsim:
             obtsym();
             if (simbolo==ident) strcpy(nom_funcion,id);
	     empareja(ident,11,&error_);
	     param_form(&lp,&tip_param_form);
             tipo_dev = vacio;
             if (simbolo==dospunto) {  /* hay tipo de retorno */
                obtsym();
                switch (simbolo) {
                  case intesim: tipo_dev = entero;
                                obtsym();
                                break;
                  case realsim: tipo_dev = real;
                                obtsym();
                                break;
                  case charsim: tipo_dev = caracter;
                                obtsym();
                                break;
                  case booleansim: tipo_dev = boolean;
                                obtsym();
                                break;
                  default: menerror(33,&error_); /* se esperaba un tipo simple de datos */
                }

             }
             entfuncion = NULL;
             if (!error_ && tip_param_form!=err) {
                entfuncion=insertar_en_func(nom_funcion,lp,interna,tipo_dev,NULL);
                if (verbo) printf("Declarada funcion: %s\n",nom_funcion);
             }
             /* si hay parametros entonces los parentesis de las acciones no */
             /* se habran consumido. Esto es por que la gramatica no es LL(1)*/
             /* de esta forma, con el primer parentesis no sabemos si es de  */
             /* los parametros o de las acciones, pero lo consumimos, si hay */
             /* parametros debemos consumir otro parentesis */
             if (lp!=NULL) empareja(abrepar,22,&error_);
             declarando_funcion = TRUE;
	     acciones(&tip_acciones);
             if (entfuncion!=NULL)  Procesa_funcion(entfuncion);
             declarando_funcion = FALSE;
	     empareja(cierrapar,21,&error_); /* el parentesis de las acciones */
             if (tip_acciones==err || tip_param_form==err) error_ = TRUE;
	     /*ver_tabla_func();*/
	     empareja(cierrapar,21,&error_);

 }
  if (error_) *tip = err;
     else     *tip =vacio;
}

void decl_function_externas(tip)
   char * tip;
{
char error_=FALSE;
char nom_funcion[long_ident+1];
char tipo_dev;
LISTA_PARAM * lp;
char param[255];
char tip_param[long_ident+1];
char tip_acciones;
int cont;
char carac;

 sincroniza(p_decl_func_extr,108,s_decl_func_extr);
 switch(simbolo){
   case externsim:
             obt_orig = TRUE;     /* el identificador debe estar tal */
                                  /* como viene en el codigo fuente */
             obtsym();
             declarando_funcion = TRUE;
             param[0]='\0';
             if (simbolo==ident) strcpy(nom_funcion,id);
             obt_orig = FALSE;
	     empareja(ident,11,&error_);
             if (simbolo==abrepar) {
                  /* si lleva parametros necesitamos acceder a ellos */
                  /* directamente sin pasar por el analizador lexico */
                  obt_orig = TRUE;
                  cont = 0;
                  while ((carac=obtch())!=')' && cont<255)
                  {
                    param[cont]=carac;
                    cont++;
                  }
                  param[cont]='\x0';
                  if (cont==255) {
                     menerror(21,&error_);
                     param[cont]='\x0';
                  }
                  obt_orig = FALSE;
                  obtsym();
             }

             tipo_dev = vacio;
             if (simbolo==dospunto) {  /* hay tipo de retorno */
                obtsym();
                switch (simbolo) {
                  case intesim: tipo_dev = entero;
                                obtsym();
                                break;
                  case realsim: tipo_dev = real;
                                obtsym();
                                break;
                  case charsim: tipo_dev = caracter;
                                obtsym();
                                break;
                  case booleansim: tipo_dev = boolean;
                                obtsym();
                                break;
                  default: menerror(33,&error_); /* se esperaba un tipo simple de datos */
                }
             }
             entfuncion = NULL;
             if (!error_ ) {
                entfuncion=insertar_en_func(nom_funcion,NULL,externa, tipo_dev,param);
                if (verbo) printf("Declarada funcion externa: %s\n",nom_funcion);
             }
	     empareja(cierrapar,21,&error_);
             declarando_funcion = FALSE;
 }
  if (error_) *tip = err;
     else     *tip =vacio;

}

void param_form(lpar,tip)
 LISTA_PARAM **lpar;
 char *tip;
{
 char error_=FALSE;
 char tip_par;
 int t_array;
 int lim_inf,lim_sup, tam_lis;
 char instancia[long_ident+1];
 char nombre_par[long_ident+1];
 REGTDS * ent_tds;
 int por_ref;
 LISTA *l;

 *lpar = NULL;
 instancia[0]='\0';
 nombre_par[0]='\0';
 sincroniza(p_param_form,22,s_param_form);
 switch(simbolo){
   case abrepar:
             obtsym();
             if (simbolo!=abrepar) {
             do {
                if (simbolo==coma) obtsym();
                if (simbolo==ident) {
                  strcpy(nombre_par,id);
                }
                empareja(ident,11,&error_);
                if (simbolo==opmult) {
                        por_ref=TRUE;
                        obtsym();
                } else  por_ref=FALSE;
/*              f_type(&tip_par,&lim_inf,&lim_sup,&tam_lis,instancia); */
/*                empareja(abrepar,22,&error_); */
	        tipo(&tip_par, &lim_inf, &lim_sup, &tam_lis, instancia, &t_array);
/* 	        empareja(cierrapar,21,&error_); */
                if (tip_par!=err) {
                   switch (tip_par) {
                          case boolean: ent_tds=crea_regtds_simple(paramt,boolean,nombre_par);
                                        break;
                          case entero: ent_tds=crea_regtds_simple(paramt,entero,nombre_par);
                                        break;
                          case real: ent_tds=crea_regtds_simple(paramt,real,nombre_par);
                                        break;
                          case caracter: ent_tds=crea_regtds_simple(paramt,caracter,nombre_par);
                                        break;
                          case definido: ent_tds=crea_regtds_tipdef(paramt,instancia,nombre_par);
                                         break;
                   }
                }
                if (!error_) {
                    if (*lpar==NULL) *lpar = cr_lista_param(*lpar,nombre_par,ent_tds,por_ref);
                               else *lpar = insertar_lista_param(*lpar,nombre_par,ent_tds,por_ref);
                }
             } while (simbolo==coma);
             empareja(cierrapar,21,&error_);
             }
 }
 if (error_) *tip = err;
     else     *tip =vacio;
}

/* FALTA: las llamadas a funciones como parte de cualquier expresion */
void llamada()
{
 sincroniza(p_llamada,11,s_llamada);
 switch(simbolo){
   case ident:
	    obtsym();
	    param_act();
	    /*printf("operaciones en la llamada\n");*/
	    /*ver_listaoperaciones(lop);*/
 }
}

/* FALTA: los parametros actuales de las funciones */
void param_act()
{
 char error_=FALSE;
 int i;

 sincroniza(p_param_act,22,s_param_act);
 switch(simbolo) {
   case abrepar:
	     obtsym();
	     i=0;
	     if(simbolo!=cierrapar)
	       do {
                 i++;
		 expr_sim();
                 if(simbolo==coma) empareja(coma,9,&error_);
               }while(pertenece(simbolo,p_expr));
	     empareja(cierrapar,21,&error_);
  }
}

void decl_estrategia(tip)
   char *tip;
{
char error_=FALSE;

 sincroniza(p_decl_estrategia,82,s_decl_estrategia);
 switch(simbolo){
   case setstrategysim:
             obtsym();
             if (simbolo==depthsim)
                 { estrategia = profundidad; }   /* estrategia=0; */
             else if(simbolo==widthsim)
                  { estrategia = anchura; }      /*  estrategia=1; */
                  else menerror(88,&error_);
             obtsym();
             empareja(cierrapar,21,&error_);
 }
 if (error_) *tip = err;
    else     *tip = vacio;
}
             
void lista_rules(char *tip) {
  char error_=FALSE;
  EXPRESION *exp_prio;
  REGREGLA * ptrotabla;
  char tip_cond;
  char tip_acc;
  char tip_prio;
  char err_procesaregla;

  sincroniza(p_lista_rules,24,s_lista_rules);
  *tip = vacio;
  switch(simbolo){
  case defrulesim:
    obtsym();
    ptrotabla = NULL;
    if (simbolo==ident) {
      if (busca_en_reglas(id)!=NULL) {
	/* error esta regla ya existe */
	menerror(69, &error_);
      }
      else {
	ptrotabla=insregla_enreglas(id,numregla);
	if (verbo) printf("Declarada regla: %s\n",id);
	numregla++;                  /* numregla contiene el codigo de la siguiente regla */
      }
    }
    empareja(ident,11, &error_);
    prio(&exp_prio,&tip_prio);
    
    if (ptrotabla!=NULL && tip_prio!=err)
      ptrotabla->expr_prio=exp_prio;
    entregla=ptrotabla;
    condiciones(ptrotabla,&tip_cond);
    empareja(implisim,17,&error_);   
    acciones(&tip_acc);
    empareja(cierrapar,21,&error_);
#ifdef DEBUG
    ver_tabla_reglas();
#endif

    if (!error_ && (tip_cond!=err) && (tip_acc!=err)) 
      Procesa_regla(ptrotabla,&err_procesaregla);
    
    if (err_procesaregla)
      menerror(79, &error_);

    if (error_ || (tip_cond==err) || (tip_acc==err))
      *tip = err;
    else 
      *tip = vacio;
    break;
  }
}

void prio(exp_prio,tip_prio)
 EXPRESION **exp_prio;
 char * tip_prio;
{
 char * error_=FALSE;
 int prioridad;
 char tip_exp;

 *exp_prio=NULL;
 sincroniza(p_prio,7,s_prio);
 if(simbolo==abrecor){
    empareja(abrecor,7,&error_);
    expr_sim(exp_prio,&tip_exp);
    /* se comprueba que se trata de una expresion entera */
    if (tip_exp == array) {
      menerror(127, &error_);
    }
    else {
      if (tip_exp!=entero)
	menerror(112,&error_);
    }

    /* si la expresion es una constante podemos comprobar */
    /* si esta dentro del rango -10..10 permitido */
    if (es_constante(*exp_prio)) {
        if ((*exp_prio)->valor.entero>10 || (*exp_prio)->valor.entero<-10)
           menerror(80,&error_);
    }

    empareja(cierracor,7,&error_);
 }
 if (error_) *tip_prio = err;
        else *tip_prio = vacio;
}

void condiciones(entregla, tip)
    REGREGLA *entregla;
    char *tip;
{
 char error_=FALSE;
 char tip_condic;
 int num_cond;
 ARB_COND *arbc,*arbc_ant;

 num_cond = 0;
 sincroniza(p_condiciones,22,s_condiciones);
 switch(simbolo){
   case abrepar:
            do{
                empareja(abrepar,22,&error_);
  	        condicion(&arbc,&tip_condic);
                num_cond++;
                if (num_cond>1 && tip_condic!=err) {
                    if (num_cond==2) entregla->condiciones = inserta_arb_condic_and(entregla->condiciones,arbc_ant);
                    entregla->condiciones = inserta_arb_condic_and(entregla->condiciones, arbc);
                }
                if (tip_condic==err) error_=TRUE;
                arbc_ant = arbc;
#ifdef DEBUG
                ver_condic(entregla->lcond);
                ver_condiciones(entregla->condiciones);
#endif
	        empareja(cierrapar,21,&error_);
            } while (simbolo==abrepar);
            if (num_cond==1 && tip_condic!=err)        /* si solo hay una condicion */
                    entregla->condiciones = arbc;

	    break;
   }
   if (error_) *tip = err;
       else    *tip = vacio;
}

void condicion(//arbc,tip)
	       ARB_COND * *arbc,
	       char * tip) { 
  
  char error_=FALSE;
  char tip_condic;
  int cond_neg;
  ARB_COND *arb_aux, *arb_ant;
  char opr;
  EXPRESION *li, *ld;
  int num_cond;
  ARB_COND *arb_or1,  *arb_or2;
  char tipoid;

  sincroniza(p_condicion,52,s_condicion);
  switch(simbolo) {
  case opnosim:
    obtsym();
    empareja(abrepar,22,&error_);
    condicion(&arb_aux,tip);
    if (*tip!=err) {
      arb_aux->esta_negada = TRUE;
      *arbc = arb_aux;
      if ((arb_aux->lado_izq->tipooperador == existe) || (arb_aux->lado_der->tipooperador == existe)) {
	menerror(124, &error_);
      }
    }
    empareja(cierrapar,21,&error_);
    break;

   case oposim: /* OR */
                obtsym();
                *arbc=NULL;
		empareja(abrepar,22,&error_);
		condicion(&arb_or1,tip);
                if (*tip==err) error_=TRUE;
		empareja(cierrapar,21,&error_);
		empareja(abrepar,22,&error_);
		condicion(&arb_or2,tip);
		empareja(cierrapar,21,&error_);
                if (*tip!=err && !error_) *arbc= inserta_arb_condic_or(*arbc,arb_or1,arb_or2);
		break;

   case abrepar: /* cuando aparecen varias condiciones agrupadas con AND */
                 *arbc=NULL;
                 num_cond =0;
                 do {
                    empareja(abrepar,22,&error_);
  	            condicion(&arb_aux,&tip_condic);
                    num_cond++;
                    if (num_cond>1 && tip_condic!=err) {
                       if (num_cond==2) *arbc = inserta_arb_condic_and(*arbc,arb_ant);
                       *arbc = inserta_arb_condic_and(*arbc, arb_aux);
                    }
                    if (tip_condic==err) error_=TRUE;
                    arb_ant = arb_aux;
    	            empareja(cierrapar,21,&error_);
                 } while (simbolo==abrepar);
                 if (num_cond==1 && tip_condic!=err)        /* si solo hay una condicion */
                    *arbc = arb_aux;
                 if (error_) *tip=err;
                        else *tip=vacio;
                 break;
/*    case ident: */
/*      /* Patrones Version 3.0 o comienzo de expresion. by Emilio 8/99 */
/*      if (simbolo==ident){ /* Sino, se ira a la siguiente opcion del switch -> default */ 
/*        if (busca_tipo_en_tds(id) == clase)  */
/* 	 /* Formato de condiciones nuevo de Arlips 3.0 */
/* 	 idclase=id ; */
/* 	 obtsym(); */
/* 	 if ((simbolo==existe) || (simbolo==paratodo)){ */
/* 	   /* Variable patron cuantificada */
/*            if (busca_tipo_en_tds(id)) menerror(70, &error_); */
/* 	   /* si ya existe en la TDS, error */
/*            else { */
/* 	     l=NULL; */
/* 	     l=cr_lista_id(l,id);} */
/* 	   empareja(ident,11,&error_); */
/* 	   if (simbolo==ident) */
/* 	     if (busca_tipo_en_tds(id)==clase) {/* debe ser una clase */
/* 	       instipdef_entds(paternvar,id,l); */
/* 	       if (verbo) printf("\tDeclarada variable patron: %s\n",l->nombre); } */
/* 	     else menerror(27,&error_);  /* error, se esperaba una clase */
/* 	     empareja(ident,27,&error_); */
/* 	     empareja(cierrapar,21,&error_); } */
/* 	 while(simbolo==abrepar); */
/* #ifdef DEBUG */
/* 	 ver_tabla_tds(); */
/* #endif */
/* 	 empareja(cierrapar,21,&error_); */
  





/* 	   break ; }} */
/*      /* A continuacion debe ir el 'default' */
   default:    /** primeros de expresion **/
               li = NULL;
               ld = NULL;
	       expresion(&opr,&li,&ld,tip);
               *arbc=crea_nodo_condic(opr,li,ld,FALSE);
	       break;
   }
   if (error_) *tip=err;
}

void acciones(char *tip) {
  char error_=FALSE;
  char tipo_ac;
  char ident_accion[long_ident+1];
  char campo_accion[long_ident+1];
  EXPRESION * exp_accion;
  EXPRESION * campos_exp;
  char tip_acc;
  char tip_lis_expr[30];
  char tip_izq;
  
  sincroniza(p_acciones,22,s_acciones);
  switch(simbolo) {
  case abrepar:
    do {
      empareja(abrepar,22,&error_);
      accion(&tipo_ac,ident_accion,campo_accion,&campos_exp,&exp_accion,&tip_acc,tip_lis_expr,&tip_izq);
      
      if (tip_acc!=err) /* si tip_acc!=err entonces contiene el tipo de la expresion de la accion */
	if (!declarando_funcion)
	  entregla->lacc = inserta_lista_acciones(entregla->lacc,tipo_ac,ident_accion, campo_accion,
						  campos_exp,exp_accion,tip_acc,tip_lis_expr,tip_izq);
	else {
	  entfuncion->lacc = inserta_lista_acciones(entfuncion->lacc, tipo_ac, ident_accion, 
						    campo_accion,campos_exp,exp_accion,tip_acc,
						    tip_lis_expr,tip_izq);
	}
      else error_=TRUE;
      empareja(cierrapar,21,&error_);
    } while (simbolo==abrepar);
  }
  if (error_)
    *tip = err;
  else
    *tip = vacio;
}

void expresion(//opr,li,ld,tip)
	       char * opr,
	       EXPRESION * * li,
	       EXPRESION * * ld,
	       char *tip) {

  char error_=FALSE;
  char tipo_exps1, tipo_exps2;
  
  sincroniza(p_expr,39,s_expr);
  if(pertenece(simbolo,p_expr)) {
    expr_sim(li,&tipo_exps1);

    switch(tipo_exps1) {
    case array:
      menerror(127, &error_);
      //Atencin, no separar ni usar break, debe continuar como en el caso err...
    case err:
      *tip = err;
      break;
    default:
      *tip = tipo_exps1;
    }

    (*opr) = nulo;
    if(simbolo==igual || simbolo==distinto || simbolo==menor ||
       simbolo==mayor || simbolo==mayorig  || simbolo==menorig ) {
      (*opr)= simbolo;
      obtsym();
      expr_sim(ld,&tipo_exps2);
    
      switch(tipo_exps2) {
      case array:
	menerror(127, &error_);
      case err:
	*tip=err;
	break;
      default:
	if ((*opr)==mayor || (*opr)==menor || (*opr)==menorig || (*opr)==mayorig) {
	  if ((tipo_exps1!=real && tipo_exps1!=entero) ||
	      (tipo_exps2!=real && tipo_exps2!=entero)) {
	    /* error se esperaba un tipo entero o real */
	    menerror(97,&error_);
	  }
	} 
	else {/* si el operador es igual o distinto */
	  if (tipo_exps1==lista_enteros || tipo_exps1==lista_reales
	      || tipo_exps2==lista_enteros || tipo_exps2==lista_reales) {
	    menerror(98,&error_);
	  }
	}
	break;
      }
      if (error_) 
	*tip=err;
    }
  }
}

void expr_sim(EXPRESION **le,
	      char *tipoexprs) {
  
  char sign; /* aqui guarda el signo */
  char oper;  /* aqui guarda la operacion */
  char tipo_te1,tipo_te2;
  char hay_signo; /* si hay un signo, no puede ser booleano */
  char error_=FALSE;

  EXPRESION **indice_array; //Cuando la expresin es un array, su ndice es una expresin simple.
  char tipo_indice_array; //Un ndice de array debe ser una expresin simple de tipo integer.
  
  sincroniza(p_expr_sim,39,s_expr_sim);
  hay_signo=FALSE;
  sign=mas; /* POR DEFECTO */
  if(simbolo==mas || simbolo==menos) {
    (*le)=inserta_lista_exp((*le),FALSE,FALSE,simbolo,0,0,NULL,entreal_vacio);
    signo(&sign);
    hay_signo=TRUE;
  }
  
  termino(le,&tipo_te1);
  if (tipo_te1==subrango)
    tipo_te1=entero;
  if (hay_signo && tipo_te1==boolean)
    menerror(104,&error_);
  *tipoexprs=tipo_te1;


  while (simbolo==mas || simbolo==menos || simbolo ==oposim) {
    oper = simbolo;
    (*le)=inserta_lista_exp((*le),FALSE,FALSE,simbolo,0,0,NULL,entreal_vacio);
    obtsym();
    termino(le,&tipo_te2);
    
    if (tipo_te2==subrango)
      tipo_te2=entero;
    if (oper==mas || oper==menos) {   /* el operador es + o - */
      if ((tipo_te1!=entero && tipo_te1!=real) ||
	  (tipo_te2!=entero && tipo_te2!=real)) {
	if (tipo_te1!=err && tipo_te2!=err) 
	  menerror(39,&error_);
      }
      else
	if (tipo_te1!=tipo_te2)
	  *tipoexprs=real; /* si alguna de ellas es real, la expresion es real */
	else
	  *tipoexprs=tipo_te1;
    } 
    else {                          /* el operador es OR */
      if (tipo_te1!=boolean || tipo_te2!=boolean) {
	if (tipo_te1!=err && tipo_te2!=err) 
	  menerror(39,&error_);
      }
      else *tipoexprs=boolean;
    }
    if (tipo_te1==err || tipo_te2==err)
      *tipoexprs = err;
  }
  if (error_)
    *tipoexprs = err;
}

void termino(EXPRESION **le,
	     char *tipoter) {

  char error_ = FALSE;
  char tipo_fac1, tipo_fac2;
  char oper;

  sincroniza(p_termino,40,s_termino);
  if(pertenece(simbolo,p_termino)) {

    factor(le,&tipo_fac1);

    if (tipo_fac1==subrango)
      tipo_fac1=entero;
    *tipoter=tipo_fac1;

    while (simbolo==opmult || simbolo == opdiv || simbolo ==opysim) {
      oper = simbolo;
      (*le)=inserta_lista_exp((*le),FALSE,FALSE,simbolo,0,0,NULL,entreal_vacio);
      obtsym();
      factor(le,&tipo_fac2);
      if (tipo_fac2==subrango) 
	tipo_fac2=entero;
      if (oper==opmult || oper==opdiv) {   /* el operador es * o / */
	if ((tipo_fac1!=entero && tipo_fac1!=real) ||
	    (tipo_fac2!=entero && tipo_fac2!=real)) {
	  if (tipo_fac1!=err && tipo_fac2!=err) 
	    menerror(39,&error_);
	}
	else
	  if (tipo_fac1!=tipo_fac2)
	    *tipoter=real; /* si alguna de ellas es real, la expresion es real */
	  else
	    *tipoter=tipo_fac1;
      } 
      else {                          /* el operador es AND */
	if (tipo_fac1!=boolean || tipo_fac2!=boolean) {
	  if (tipo_fac1!=err && tipo_fac2!=err)
	    menerror(39,&error_);
	} 
	else
	  *tipoter=boolean;
      }
      if (tipo_fac1==err || tipo_fac2==err)
	*tipoter = err;
    }
    if (error_)
      *tipoter = err;
  }
  else {
  }
}

void factor(EXPRESION **le,
	    char *tipof) {

  char error_=FALSE;
  char tipoid;
  ENTREAL numaux;
  LISTA_CAMPOS *campo, *camp_aux;
  REGTDS * ptrotds;
  char tip_campo;
  REGTIPO * entclase;
  REGFUNC * func;
  LISTA_PARAM *lp;
  char tip_exp;
  EXPRESION *expaux,*expaux2;
  LISTA_PARAM *lparam;
  int num_param;
  REGTDS *tdsaux;
  char tipo_indice;
  EXPRESION *expr_indice_array;
  
  
  sincroniza(p_factor,45,s_factor);
  switch(simbolo) {
  case existe:
    obtsym();
    if (simbolo==ident) {
      tipoid = busca_tipo_en_tds(id);
      ptrotds = elemtds;
      if (ptrotds!=NULL) 
	camp_aux = ptrotds->lc;
      if (tipoid==paternvar) {
	/* primero insertamos el operador existe */
	(*le)=inserta_lista_exp((*le), FALSE,FALSE,existe,0,0,NULL,entreal_vacio);
	/* despues se inserta en la expresion la propia variable patron */
	(*le)=inserta_lista_exp((*le),TRUE,FALSE, 0,ptrotds->tipo,paternvar,id,entreal_vacio);
	*tipof=ptrotds->tipo;
	
      } 
      else {
	/* error no es una variable patron, que son */
	/* los unicos operandos que pueden ir cuantificados */
	menerror(49,&error_);
	*tipof=err;
      }
    }
    empareja(ident,11, &error_);
    while (simbolo==punto) {     /* si subcampos se consumen */
      obtsym();
      if (simbolo==ident)
	if ((campo=busca_campo(id,camp_aux))!=NULL) {
	  /* primero insertamos el operador punto */
	  (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
	  /* despues se inserta en la expresion el campo */
	  (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);
	  
	  ///////////////////////
	  if (campo->tipo == array) {
	    obtsym();
	    if (simbolo == abrecor) {
	      *tipof = campo->tbase_array;
	      empareja(abrecor, 127, &error_);
	      expr_indice_array = *le;
	      while (expr_indice_array->sig != NULL) {
		expr_indice_array = expr_indice_array->sig;
	      }
	      expr_sim(&expr_indice_array->indice_array, &tipo_indice);
	      if (tipo_indice != entero) {
		menerror(112, &error_);
	      }
	      empareja(cierracor, 101, &error_);
	    }
	    else {
	      *tipof = array;
	      marcar_campo_iclase_buscado(id, ptrotds->instancia_de);
	      break;
	    }
	  }
	  else 
	    *tipof = campo->tipo;
	  camp_aux = campo->lc; /* no importa que sea NULL */
	  
	  //Como se trataba de una var patrn, hay que marcar como usadas 
	  //todas las instancias de esa clase,pero solo para el campo correspondiente
	  //id contendr el identificador del campo, mientras que el segundo parmetro 
	  //es el nombre de la clase	  
	  marcar_campo_iclase_buscado(id, ptrotds->instancia_de);
	}
	else {
	  /* ese indentificador no es un subcampo de */
	  /* la var patron */
	  menerror(86,&error_);
	  *tipof=err;
	}
      if (campo->tipo != array)
	empareja(ident,11, &error_);
    }
    break;

  case paratodo: 
    obtsym();
    if (simbolo==ident) {
      tipoid=busca_tipo_en_tds(id);
      ptrotds = elemtds;
      if (ptrotds!=NULL)
	camp_aux = ptrotds->lc;
      if (tipoid==paternvar) {
	/* primero insertamos el operador paratodo */
	(*le)=inserta_lista_exp((*le), FALSE,FALSE, paratodo,0,0,NULL,entreal_vacio);
	/* despues se inserta en la expresion la propia variable patron */
	(*le)=inserta_lista_exp((*le),TRUE,FALSE, 0,ptrotds->tipo,paternvar,id,entreal_vacio);
      }
      else {
	/* error no es una variable patron, que son */
	/* los unicos operandos que pueden ir cuantificados */
	menerror(49,&error_);
	*tipof=err;
      }
    }
    empareja(ident,11, &error_);
    while (simbolo==punto) {        /* si hay un subcampo se consume */
      obtsym();
      if (simbolo==ident)
	if ((campo=busca_campo(id,camp_aux))!=NULL) {
	  /* primero insertamos el operador punto */
	  (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
	  /* despues se inserta en la expresion el campo */
	  (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);

	  if (campo->tipo == array) {
	    obtsym();
	    if (simbolo == abrecor) {
	      *tipof = campo->tbase_array;
	      empareja(abrecor, 127, &error_);
	      expr_indice_array = *le;
	      while (expr_indice_array->sig != NULL) {
		expr_indice_array = expr_indice_array->sig;
	      }
	      expr_sim(&expr_indice_array->indice_array, &tipo_indice);
	      if (tipo_indice != entero) {
		menerror(112, &error_);
	      }
	      empareja(cierracor, 101, &error_);
	    }
	    else {
	      *tipof = array;
	      marcar_campo_iclase_buscado(id, ptrotds->instancia_de);
	      break;
	    }
	  }
	  else 
	    *tipof=campo->tipo;
	  camp_aux = campo->lc; /* no importa que sea NULL */
	  
	  marcar_campo_iclase_buscado(id, ptrotds->instancia_de);
	}
	else {
	  /* ese indentificador no es un subcampo de */
	  /* la var patron */
	  menerror(86,&error_);
	  *tipof=err;
	}
      if (campo->tipo != array)
	empareja(ident,11, &error_);
    }
    break;

  case numero:
    if (esreal) {
      numaux.real=num;
      *tipof=real;
    }
    else {
      numaux.entero=num;
      *tipof=entero;
    }
    (*le)=inserta_lista_exp((*le),TRUE,FALSE,0,*tipof,constante,NULL,numaux);
    obtsym();
    break;

 case truesim:  (*le)=inserta_lista_exp((*le),TRUE,FALSE,truesim,boolean,constante,NULL,entreal_vacio);
                *tipof = boolean;
	        obtsym();
	        break;

 case falsesim:  (*le)=inserta_lista_exp((*le),TRUE,FALSE,falsesim,boolean,constante,NULL,entreal_vacio);
                *tipof = boolean;
	         obtsym();
	         break;

 case abrepar: obtsym();
               (*le)=inserta_lista_exp((*le), FALSE,FALSE, abrepar,0,0,NULL,entreal_vacio);
	       expr_sim(le,tipof);
               if (simbolo==cierrapar) (*le)=inserta_lista_exp((*le), FALSE,FALSE, cierrapar,0,0,NULL,entreal_vacio);
	       empareja(cierrapar,21,&error_);
               if (error_) *tipof=err;
	       break;

 case ident:
              if (simbolo==ident) {
                  tipoid=busca_tipo_en_tds(id);
                  ptrotds = elemtds;
                  if (ptrotds!=NULL) camp_aux = ptrotds->lc;
                  switch (tipoid) {

		  case constante:  /* CONSTANTE */
		    (*le)=inserta_lista_exp((*le), TRUE,FALSE, 0,elemtds->tipo,constante,NULL,elemtds->valor);
		    *tipof=elemtds->tipo;
		    obtsym();
		    break;

		  case instancia:  /* INSTANCIA */
		    (*le)=inserta_lista_exp((*le), TRUE,FALSE, 0,elemtds->tipo,instancia,id,entreal_vacio);
		    if (elemtds->tipo == array) {
		      obtsym();
		      if (simbolo == abrecor) {
			*tipof=elemtds->tbase_array;
			empareja(abrecor, 127, &error_);
			expr_indice_array = *le;
			while (expr_indice_array->sig != NULL) {
			  expr_indice_array = expr_indice_array->sig;
			}
			expr_sim(&expr_indice_array->indice_array, &tipo_indice);
			if (tipo_indice != entero) {
			  menerror(112, &error_);
			}
			empareja(cierracor, 101, &error_);
		      }
		      else {
			*tipof = elemtds->tipo;
			break;
		      }
		    }
		    else {
		      *tipof=elemtds->tipo;
		      empareja(ident,11, &error_);
		    }
		    
		    while (simbolo==punto) {        /* si hay un subcampo se consume */
		      obtsym();
		      if (simbolo==ident)
			if ((campo=busca_campo(id,camp_aux))!=NULL) {
			  /* primero insertamos el operador punto */
			  (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
			  /* despues se inserta en la expresion el campo */
			  (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,instancia,id,entreal_vacio);
                          
			  if (campo->tipo == array) {
			    obtsym();
			    if (simbolo == abrecor) {
			      *tipof = campo->tbase_array;
			      empareja(abrecor, 127, &error_); 
			      expr_indice_array = *le;
			      while (expr_indice_array->sig != NULL) {
				expr_indice_array = expr_indice_array->sig;
			      }
			      expr_sim(&expr_indice_array->indice_array, &tipo_indice);
			      if (tipo_indice != entero) { 
				menerror(112, &error_);
			      }
			      empareja(cierracor, 101, &error_);
			    }
			    else {
			      *tipof = campo->tipo;
			      break;
			    }
			  }
			  else {
			    *tipof = campo->tipo;
			  }
                                
			  camp_aux = campo->lc; /* no importa que sea NULL */
			}
			else {
			  /* ese indentificador no es un subcampo de */
			  /* la instancia */
			  menerror(86,&error_);
			  *tipof=err;
			}
		      if (campo->tipo != array)
			empareja(ident,11, &error_);
		    }
		    break;

		  case paramt:  /* PARAMETRO */
		    /* si es un parametro, seguro que estamos dentro de una funcion */
		    /* y que es un parametro de esa funcion */
		    (*le)=inserta_lista_exp((*le), TRUE,FALSE, 0,elemtds->tipo,paramt,id,entreal_vacio);
		    if (elemtds->tipo == array) {
		      obtsym();
		      if (simbolo == abrecor) {
			*tipof = elemtds->tbase_array;
			empareja(abrecor, 127, &error_);
			expr_indice_array = *le;
			while (expr_indice_array->sig != NULL) {
			  expr_indice_array = expr_indice_array->sig;
			}
			expr_sim(&expr_indice_array->indice_array, &tipo_indice);
			if (tipo_indice != entero) {
			  menerror(112, &error_);
			}
			empareja(cierracor, 101, &error_);
		      }
		      else {
			*tipof = array;
			break;
		      }
		    }
		    else {
		      *tipof=elemtds->tipo;
		      empareja(ident,11, &error_);
		    }
		    while (simbolo==punto) {        /* si hay un subcampo se consume */
		      obtsym();
		      if (simbolo==ident)
			if ((campo=busca_campo(id,camp_aux))!=NULL) {
			  /* primero insertamos el operador punto */
			  (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
			  /* despues se inserta en la expresion el campo */
			  (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,paramt,id,entreal_vacio);
			  
			  if (campo->tipo == array) {
			    obtsym();
			    if (simbolo == abrecor) {
			      *tipof = campo->tbase_array;
			      empareja(abrecor, 127, &error_);
			      expr_indice_array = *le;
			      while (expr_indice_array->sig != NULL) {
				expr_indice_array = expr_indice_array->sig;
			      }
			      expr_sim(&expr_indice_array->indice_array, &tipo_indice);
			      if (tipo_indice != entero) {
				menerror(112, &error_);
			      }
			      empareja(cierracor, 101, &error_);
			    }
			    else {
			      *tipof = array;
			      break;
			    }
			  }
			  else {
			    *tipof = campo->tipo;
			  }			     
			  camp_aux = campo->lc;
			}
			else {
			  /* ese indentificador no es un subcampo de */
			  /* la instancia */
			  menerror(86,&error_);
			  *tipof=err;
			}
		      if (campo->tipo != array)
			empareja(ident,11, &error_);
		    }
		    break;
		    
		  case var:  /* VARIABLE */
		    (*le)=inserta_lista_exp((*le), TRUE,FALSE, 0,elemtds->tipo,var,id,entreal_vacio);
		    if (elemtds->tipo == array) {
		      obtsym();
		      if (simbolo == abrecor) {
			*tipof = elemtds->tbase_array;
			empareja(abrecor, 127, &error_);
			expr_indice_array = *le;
			while (expr_indice_array->sig != NULL) {
			  expr_indice_array = expr_indice_array->sig;
			}
			expr_sim(&expr_indice_array->indice_array, &tipo_indice);
			if (tipo_indice != entero) {
			  menerror(112, &error_);
			}
			empareja(cierracor, 101, &error_);
		      }
		      else {
			*tipof = array;
			break;
		      }
		    }
		    else {
		      *tipof=elemtds->tipo;
		      empareja(ident,11, &error_);
		    }
		    
		    while (simbolo==punto) {        /* si hay un subcampo se consume */
		      obtsym();
		      if (simbolo==ident)
			if ((campo=busca_campo(id,camp_aux))!=NULL) {
			  /* primero insertamos el operador punto */
			  (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
			  /* despues se inserta en la expresion el campo */
			  (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,var,id,entreal_vacio);
			  
			  if (campo->tipo == array) {
			    obtsym();
			    if (simbolo == abrecor) {
			      *tipof = campo->tbase_array;
			      empareja(abrecor, 127, &error_);
			      expr_indice_array = *le;
			      while (expr_indice_array->sig != NULL) {
				expr_indice_array = expr_indice_array->sig;
			      }
			      expr_sim(&expr_indice_array->indice_array, &tipo_indice);
			      if (tipo_indice != entero) {
				menerror(112, &error_);
			      }
			      empareja(cierracor, 101, &error_);
			    }
			    else {
			      *tipof = array;
			      break;
			    }
			  }
			  else {
			    *tipof = campo->tipo;
			  }			     
			  camp_aux = campo->lc;
			}
			else {
			  /* ese indentificador no es un subcampo de */
			  /* la variable */
			  menerror(86,&error_);
			  *tipof=err;
			}
		      if (campo->tipo != array)
			empareja(ident,11, &error_);
		    }
		    break;
		    
		  default:
                         func = busca_en_funciones(id);
                         if (func!=NULL) {  /* FUNCION */
                            if (func->tipo_dev!=vacio) {
                               if (func->tipo==interna)
                                   (*le)=inserta_lista_exp((*le), TRUE,FALSE, 0,func->tipo_dev,funcion,func->nombre,entreal_vacio);
                               else
                                   (*le)=inserta_lista_exp((*le), TRUE,FALSE, 0,func->tipo_dev,funcion,func->nombre_ext,entreal_vacio);
                               *tipof=func->tipo_dev;
                               obtsym();
                               (*le)=inserta_lista_exp((*le), FALSE,FALSE, abrepar,0,0,NULL,entreal_vacio);
                               if (simbolo==abrepar) { /* lleva parametros */
                                  obtsym();
                                  lparam = func->lp;
                                  num_param= 0;
                                  do {
                                     if (lparam==NULL && func->tipo==interna) {
                                        /* no hay mas parametros: numero de parametros incorrecto */
                                        menerror(90,&error_);
                                     } else {
                                       expr_sim(le,&tip_exp);
                                       if (func->tipo==interna) 
                                       {
                                       	  expaux2=busca_expresion(*le,num_param);
                                          if (lparam->ptro->tipo!=tip_exp) {
                                          /* FALTA: la comprobacion de parametros mas a fondo */
                                          /* tipo parametro incorrecto */
                                            menerror(107,&error_);
                                          } else if (tip_exp==definido) /* si los dos son de tipo definido */
                                              {
                                                expaux = expaux2;
                                                if (expaux->sig!=NULL) {
                                                   tdsaux = busca_en_tds(expaux->ident);
                                                   campo = tdsaux->lc;
                                                   while (expaux->sig!=NULL) {
                                                         expaux=expaux->sig;  /* pasamos el punto */
                                                         expaux=expaux->sig;
                                                         campo=busca_campo(id,campo);
                                                   }
                                                   if (strcmp(lparam->ptro->instancia_de,campo->instancia_de))
                                                   {   /* si no son de la misma clase */
                                                       menerror(107,&error_);
                                                   }
                                                } else {
                                                  tdsaux = busca_en_tds(expaux->ident);
                                                  if (strcmp(lparam->ptro->instancia_de,tdsaux->instancia_de))
                                                  { /* si no son de la misma clase */
                                                    menerror(107,&error_);
                                                  }
                                                }
                                              }
                                             /* si se trata de un parametro por referencia y se ha */
                                             /* llamado con una expresion que contiene operadores, */
                                             /* constantes,etc */
                                             if (lparam->por_ref && !es_obj_simple(expaux2)) {
                                                menerror(109,&error_);
                                             }
                                             lparam=lparam->sig;
                                       }
                                       num_param++;
                                     }
                                     if(simbolo==coma) {
                                          *le=inserta_lista_exp(*le,FALSE,FALSE,coma,0,0,NULL,entreal_vacio);
                                          obtsym();
                                     }
                                  } while (simbolo!=cierrapar && !error_);
                                  if (lparam!=NULL) {
                                     /* faltan parametros : numero de parametros incorrecto */
                                     menerror(90,&error_);
                                  }
                                  empareja(cierrapar,21,&error_);
                               }
                               (*le)=inserta_lista_exp((*le), FALSE,FALSE, cierrapar,0,0,NULL,entreal_vacio);
                            } else {/* esta funcion no devuelve un valor */
                               menerror(111,&error_);
                            }
                         } else {
                            if (!tipoid) menerror(91,&error_); /* no esta en la TDS */
                              /* FALTA: error no es ni una instancia, ni una cte */
                            *tipof=err;
                            obtsym();
                         }
                   }
              }
      	      break;
   case sizesim : obtsym();
                  /* primero insertamos el operador sizesim */
                  (*le)=inserta_lista_exp((*le), FALSE,FALSE, sizesim,0,0,NULL,entreal_vacio);
                  (*le)=inserta_lista_exp((*le), FALSE,FALSE, abrepar,0,0,NULL,entreal_vacio);
                  empareja(abrepar,22,&error_);
                  if (simbolo==existe) {
                     (*le)=inserta_lista_exp((*le), FALSE,FALSE, existe,0,0,NULL,entreal_vacio);
                     obtsym();
                  }
                  if (simbolo==ident) {
                    tipoid=busca_tipo_en_tds(id);
                    ptrotds= elemtds;
                    if (ptrotds!=NULL) camp_aux = ptrotds->lc;
                    if (tipoid==paternvar || tipoid==instancia || tipoid==paramt || tipoid == var) {
                       /* despues se inserta en la expresion la propia variable patron */
                       (*le)=inserta_lista_exp((*le),TRUE,FALSE, 0,ptrotds->tipo,tipoid,id,entreal_vacio);
                       *tipof = entero;
                       /* FALTA: si es instancia simple y no es lista */
                    } else {
                      /* error no es ni una instancia ni una variable patron */
                      menerror(49,&error_);
                      *tipof=err;
                    }
                 }
                 empareja(ident,11, &error_);
                 while (simbolo==punto) {        /* si hay un subcampo se consume */
                     obtsym();
                   if (simbolo==ident)
                      if ((campo=busca_campo(id,camp_aux))!=NULL) {
                         tip_campo = campo->tipo;
                         if (tip_campo==lista_enteros || tip_campo==lista_reales || tip_campo==definido) {
                           /* primero insertamos el operador punto */
                           (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
                           /* despues se inserta en la expresion el campo */
                           (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);
                           *tipof = entero;

                           camp_aux = campo->lc; /* no importa que sea NULL */
                         }
                         else     /* se esperaba un tipo lista */
                                     menerror(93,&error_);
                      }
                      else {
                          /* ese indentificador no es un subcampo de */
                          /* la var patron */
                          menerror(86,&error_);
                          *tipof=err;
                      }
                   empareja(ident,11, &error_);
               }
               empareja(cierrapar,21,&error_);
               (*le)=inserta_lista_exp((*le), FALSE,FALSE, cierrapar,0,0,NULL,entreal_vacio);
	       break;

   case headsim :
     obtsym();
     /* primero insertamos el operador headsim */
     (*le)=inserta_lista_exp((*le), FALSE,FALSE, headsim,0,0,NULL,entreal_vacio);
     (*le)=inserta_lista_exp((*le), FALSE,FALSE, abrepar,0,0,NULL,entreal_vacio);
     empareja(abrepar,22,&error_);
     if (simbolo==existe) {
       (*le)=inserta_lista_exp((*le), FALSE,FALSE, existe,0,0,NULL,entreal_vacio);
       obtsym();
     }
     if (simbolo==ident) {
       tipoid=busca_tipo_en_tds(id);
       ptrotds= elemtds;
       if (ptrotds!=NULL)
	 camp_aux = ptrotds->lc;
       if (tipoid==paternvar || tipoid==instancia || tipoid==paramt || tipoid == var) {
	 /* despues se inserta en la expresion la propia variable patron */
	 (*le)=inserta_lista_exp((*le),TRUE,FALSE, 0,ptrotds->tipo,tipoid,id,entreal_vacio);
	 switch (ptrotds->tipo) {   /* la funcion head devuelve su contenido */
	 case lista_enteros:
	   *tipof = entero;
	   break;
	 case lista_reales:
	   *tipof = real;
	   break;
	 }
	 /* FALTA: si es instancia simple y no es lista */
       }
       else {
	 /* error no es ni una instancia ni una variable patron */
	 menerror(49,&error_);
	 *tipof=err;
       }
     }
     empareja(ident,11, &error_);
     while (simbolo==punto) {        /* si hay un subcampo se consume */
       obtsym();
       if (simbolo==ident)
	 if ((campo=busca_campo(id,camp_aux))!=NULL) {
	   tip_campo = campo->tipo;
	   if (tip_campo==lista_enteros || tip_campo==lista_reales || tip_campo==definido) {
	     /* primero insertamos el operador punto */
	     (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
	     /* despues se inserta en la expresion el campo */
	     (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);
	     switch (campo->tipo) {   /* la funcion head devuelve su contenido */
	     case lista_enteros:
	       *tipof = entero;
	       break;
	     case lista_reales:
	       *tipof = real;
	       break;
	     }
	     camp_aux = campo->lc; /* no importa que sea NULL */
	   }
	   else     /* se esperaba un tipo lista */
	     menerror(93,&error_);
	 }
	 else {
	   /* ese indentificador no es un subcampo de */
	   /* la var patron */
	   menerror(86,&error_);
	   *tipof=err;
	 }
       empareja(ident,11, &error_);
     }
     empareja(cierrapar,21,&error_);
     (*le)=inserta_lista_exp((*le), FALSE,FALSE, cierrapar,0,0,NULL,entreal_vacio);
     break;

   case tailsim :
     obtsym();
     /* primero insertamos el operador tailsim */
     (*le)=inserta_lista_exp((*le), FALSE,FALSE, tailsim,0,0,NULL,entreal_vacio);
     (*le)=inserta_lista_exp((*le), FALSE,FALSE, abrepar,0,0,NULL,entreal_vacio);
     empareja(abrepar,22,&error_);
     if (simbolo==existe) {
       (*le)=inserta_lista_exp((*le), FALSE,FALSE, existe,0,0,NULL,entreal_vacio);
       obtsym();
     }
     if (simbolo==ident) {
       tipoid=busca_tipo_en_tds(id);
       ptrotds= elemtds;
       if (ptrotds!=NULL)
	 camp_aux = ptrotds->lc;
       if (tipoid==paternvar || tipoid==instancia || tipoid==paramt || tipoid == var) {
	 /* despues se inserta en la expresion la propia variable patron */
	 (*le)=inserta_lista_exp((*le),TRUE,FALSE, 0,ptrotds->tipo,tipoid,id,entreal_vacio);
	 switch (ptrotds->tipo) {   /* la funcion head devuelve su contenido */
	 case lista_enteros:
	   *tipof = entero;
	   break;
	 case lista_reales:
	   *tipof = real;
	   break;
	 }
	 /* FALTA: si es instancia simple y no es lista */
       }
       else {
	 /* error no es ni una instancia ni una variable patron */
	 menerror(49,&error_);
	 *tipof=err;
       }
     }
     empareja(ident,11, &error_);
     while (simbolo==punto) {        /* si hay un subcampo se consume */
       obtsym();
       if (simbolo==ident)
	 if ((campo=busca_campo(id,camp_aux))!=NULL) {
	   tip_campo = campo->tipo;
	   if (tip_campo==lista_enteros || tip_campo==lista_reales || tip_campo==definido) {
	     /* primero insertamos el operador punto */
	     (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
	     /* despues se inserta en la expresion el campo */
	     (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);
	     switch (campo->tipo) {   /* la funcion head devuelve su contenido */
	     case lista_enteros: *tipof = entero;
	       break;
	     case lista_reales: *tipof = real;
	       break;
	     }
	     camp_aux = campo->lc; /* no importa que sea NULL */
	   }
	   else     /* se esperaba un tipo lista */
	     menerror(93,&error_);
	 }
	 else {
	   /* ese indentificador no es un subcampo de */
	   /* la var patron */
	   menerror(86,&error_);
	   *tipof=err;
	 }
       empareja(ident,11, &error_);
     }
     empareja(cierrapar,21,&error_);
     (*le)=inserta_lista_exp((*le), FALSE,FALSE, cierrapar,0,0,NULL,entreal_vacio);
     break;
  case popheadsim:
    obtsym();
    /* primero insertamos el operador popheadsim */
    (*le)=inserta_lista_exp((*le), FALSE,FALSE, popheadsim,0,0,NULL,entreal_vacio);
    (*le)=inserta_lista_exp((*le), FALSE,FALSE, abrepar,0,0,NULL,entreal_vacio);
    empareja(abrepar,22,&error_);
    if (simbolo==existe) {
      (*le)=inserta_lista_exp((*le), FALSE,FALSE, existe,0,0,NULL,entreal_vacio);
      obtsym();
    }
    if (simbolo==ident) {
      tipoid=busca_tipo_en_tds(id);
      ptrotds= elemtds;
      if (ptrotds!=NULL) camp_aux = ptrotds->lc;
      if (tipoid==paternvar || tipoid==instancia || tipoid==paramt || tipoid == var) {
	/* despues se inserta en la expresion la propia variable patron */
	(*le)=inserta_lista_exp((*le),TRUE,FALSE, 0,ptrotds->tipo,tipoid,id,entreal_vacio);
	switch (ptrotds->tipo) {   /* la funcion head devuelve su contenido */
	case lista_enteros:
	  *tipof = entero;
	  break;
	case lista_reales:
	  *tipof = real;
	  break;
	}
	/* FALTA: si es instancia simple y no es lista */
      } 
      else {
	/* error no es ni una instancia ni una variable patron */
	menerror(49,&error_);
	*tipof=err;
      }
    }
    empareja(ident,11, &error_);
    while (simbolo==punto) {        /* si hay un subcampo se consume */
      obtsym();
      if (simbolo==ident)
	if ((campo=busca_campo(id,camp_aux))!=NULL) {
	  tip_campo = campo->tipo;
	  if (tip_campo==lista_enteros || tip_campo==lista_reales || tip_campo==definido) {
	    /* primero insertamos el operador punto */
	    (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
	    /* despues se inserta en la expresion el campo */
	    (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);
	    switch (campo->tipo) {   /* la funcion popheadsim devuelve su contenido */
	    case lista_enteros:
	      *tipof = entero;
	      break;
	    case lista_reales: 
	      *tipof = real;
	      break;
	    }
	    camp_aux = campo->lc; /* no importa que sea NULL */
	  }
	  else     /* se esperaba un tipo lista */
	    menerror(93,&error_);
	}
	else {
	  /* ese indentificador no es un subcampo de */
	  /* la var patron */
	  menerror(86,&error_);
	  *tipof=err;
	}
      empareja(ident,11, &error_);
    }
    empareja(cierrapar,21,&error_);
    (*le)=inserta_lista_exp((*le), FALSE,FALSE, cierrapar,0,0,NULL,entreal_vacio);
    break;
    
  case poptailsim : 
     obtsym();
     /* primero insertamos el operador tailsim */
     (*le)=inserta_lista_exp((*le), FALSE,FALSE, poptailsim,0,0,NULL,entreal_vacio);
     (*le)=inserta_lista_exp((*le), FALSE,FALSE, abrepar,0,0,NULL,entreal_vacio);
     empareja(abrepar,22,&error_);
     if (simbolo==existe) {
       (*le)=inserta_lista_exp((*le), FALSE,FALSE, existe,0,0,NULL,entreal_vacio);
       obtsym();
     }
     if (simbolo==ident) {
       tipoid=busca_tipo_en_tds(id);
       ptrotds= elemtds;
       if (ptrotds!=NULL) camp_aux = ptrotds->lc;
       if (tipoid==paternvar || tipoid==instancia || tipoid==paramt || tipoid == var) {
	 /* despues se inserta en la expresion la propia variable patron */
	 (*le)=inserta_lista_exp((*le),TRUE,FALSE, 0,ptrotds->tipo,tipoid,id,entreal_vacio);
	 switch (ptrotds->tipo) {   /* la funcion poptailsim devuelve su contenido */
	 case lista_enteros: 
	   *tipof = entero;
	   break;
	 case lista_reales:
	   *tipof = real;
	   break;
	 }
	 /* FALTA: si es instancia simple y no es lista */
       } 
       else {
	 /* error no es ni una instancia ni una variable patron */
	 menerror(49,&error_);
	 *tipof=err;
       }
     }
     empareja(ident,11, &error_);
     while (simbolo==punto) {        /* si hay un subcampo se consume */
       obtsym();
       if (simbolo==ident)
	 if ((campo=busca_campo(id,camp_aux))!=NULL) {
	   tip_campo = campo->tipo;
	   if (tip_campo==lista_enteros || tip_campo==lista_reales || tip_campo==definido) {
	     /* primero insertamos el operador punto */
	     (*le)=inserta_lista_exp((*le), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
	     /* despues se inserta en la expresion el campo */
	     (*le)=inserta_lista_exp((*le),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);
	     switch (campo->tipo) {   /* la funcion head devuelve su contenido */
	     case lista_enteros: *tipof = entero;
	       break;
	     case lista_reales: *tipof = real;
	       break;
	     }
	     camp_aux = campo->lc; /* no importa que sea NULL */
	   }
	   else     /* se esperaba un tipo lista */
	     menerror(93,&error_);
	 }
	 else {
	   /* ese indentificador no es un subcampo de */
	   /* la var patron */
	   menerror(86,&error_);
	   *tipof=err;
	 }
       empareja(ident,11, &error_);
     }
     empareja(cierrapar,21,&error_);
     (*le)=inserta_lista_exp((*le), FALSE,FALSE, cierrapar,0,0,NULL,entreal_vacio);
     break;
     
  }
}

void signo(op)
 char * op; /* aqui devuelvo el signo*/
{
  sincroniza(p_signo,41,s_signo);
  switch(simbolo){
    case mas:  *op=mas;
	       obtsym();
	       break;
    case menos: *op=menos;
		obtsym();
		break;
    default:  menerror_1(29);
  }
}

void accion(char *tipoac, 
	    char *ident_accion, 
	    char *campo_accion, 
	    EXPRESION **campos_expr,
	    EXPRESION **expr_accion,
	    char *tip,
	    char *tip_lista_expr,
	    char *tip_izq) {

  char error_=FALSE;
  char tipoid;
  LISTA_CAMPOS *campo, *camp_aux;
  REGTDS * ptrotds;
  char oprel;
  EXPRESION * lado_izq ;
  EXPRESION * lado_der ;
  char tip_expr;
  char tip_campo;
  REGFUNC *auxfunc;
  LISTA_PARAM *lparam;
  REGTDS * tdsaux;
  EXPRESION * expaux, *expaux2;
  int num_param;
  char tipo_indice;
  EXPRESION *expr_indice_array;

  sincroniza(p_accion,8,s_accion);
  switch(simbolo){
    
  case existe: 
    obtsym();
    if (declarando_funcion)     /* si es una funcion entonces es un accion erronea */
      menerror(105,&error_);
    if (simbolo==ident) {
      tipoid=busca_tipo_en_tds(id);
      ptrotds= elemtds;
      if (ptrotds!=NULL)
	camp_aux = ptrotds->lc;
      if (tipoid==paternvar) {
	*tipoac=asig_patter;
	strcpy(ident_accion,id);
      }
      else {
	/* error no es una variable patron, que son */
	/* los unicos operandos que pueden ir cuantificados */
	menerror(49,&error_);
      }
    }
    empareja(ident,11, &error_);
    (*campos_expr) = NULL;
    while (simbolo==punto) {      /* si subcampos se consumen */
      obtsym();                /* debe haberlo, ya que las variables patron solo */
      if (simbolo==ident)      /* son de clases (con campos) */
	if ((campo=busca_campo(id,camp_aux))!=NULL) {
	  (*campos_expr)=inserta_lista_exp((*campos_expr), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
	  /* despues se inserta en la expresion el campo */
	  (*campos_expr)=inserta_lista_exp((*campos_expr),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);
	  tip_campo = campo->tipo;
	  camp_aux = campo->lc;
	  strcpy(campo_accion,id);

	  if (campo->tipo == array) {
	    tip_campo = campo->tbase_array;
	    obtsym();
	    empareja(abrecor, 127, &error_);
	    expr_indice_array = *campos_expr;
	    while (expr_indice_array->sig != NULL) {
	      expr_indice_array = expr_indice_array->sig;
	    }
	    expr_sim(&expr_indice_array->indice_array, &tipo_indice);
	    if (tipo_indice != entero) {
	      menerror(112, &error_);
	    }
	    empareja(cierracor, 101, &error_);
	  }
	  else {
	    empareja(ident, 11, &error_);
	  }

	}
	else {
	  /* ese indentificador no es un subcampo de */
	  /* la var patron */
	  menerror(86,&error_);
	}
      else {
	empareja(ident,11, &error_);
      }
    }
    *tip_izq=tip_campo;
    if (tip_campo == array) {
      tip_campo = ptrotds->tbase_array;
      *tip_izq = ptrotds->tbase_array;
      empareja(abrecor, 127, &error_);
      expr_sim(campos_expr, &tipo_indice);
      if (tipo_indice != entero) {
	menerror(112, &error_);
      }
      empareja(cierracor, 101, &error_);
    }
    empareja(asigna,14,&error_);
    lado_izq=NULL;
    lado_der=NULL;
    expresion(&oprel,&lado_izq,&lado_der,&tip_expr);
    *expr_accion=lado_izq;
    
    /* comprobacion de tipos */
    if (tip_expr!=tip_campo)
      if (tip_expr==entero && tip_campo==real) tip_expr=entero;
      else
	if (tip_campo==subrango && tip_expr==entero) {
	  if ((*expr_accion)->esoperando && (*expr_accion)->claseoperando==constante) {
	    /* si se puede se comprueba el rango */
	    if ((*expr_accion)->valor.entero<campo->lim_inf || (*expr_accion)->valor.entero>campo->lim_sup)
	      menerror(71,&error_);
	  }
	}
	else menerror(3,&error_);
    
    
    if ((tip_expr==err) || error_)
      *tip= err;
    else
      *tip=tip_expr;
    break;
    
  case prinsim:
    obtsym();
    *tipoac=imprimir;
    empareja(abrepar,22,&error_);
    *campos_expr=NULL;
    *expr_accion=NULL;
    *campo_accion = '\x0';
    *ident_accion = '\x0';
    lista_exp(expr_accion,tip_lista_expr);
    empareja(cierrapar,21,&error_);
    if ((tip_lista_expr[0]==err) || error_) 
      *tip=err;
    else 
      *tip=tip_lista_expr[0];
    break;

  case factssim:
    //Nos basamos en case haltsim:
    *tipoac = log_facts;
    obtsym();
    break;
    
  case returnsim:
    obtsym();
    empareja(abrepar,22,&error_);
    if (declarando_funcion)
      *tipoac=retorno_subprg;
    else
      menerror(106,&error_);
    *ident_accion='\x0';
    *campo_accion='\x0';
    lado_izq=NULL;
    lado_der=NULL;
    expresion(&oprel,&lado_izq,&lado_der,&tip_expr);
    *expr_accion=lado_izq;
    empareja(cierrapar,21,&error_);
    if ((tip_expr==err) || error_) 
      *tip=err;
    else
      *tip=tip_expr;
    break;
	       
  case addheadsim:
    obtsym();
    *tipoac=oplista_addhead;
    empareja(abrepar,22,&error_);
    *expr_accion=NULL;

    expr_sim(expr_accion, &tip_expr);

    if (tip_expr!=entero && tip_expr!=real) 
      menerror(97,&error_);

    if (simbolo == existe) {
      obtsym();
      if (simbolo == ident) {
	tipoid=busca_tipo_en_tds(id);
	if (tipoid != paternvar) {
	  menerror(49,&error_);
	}
      }
    }

    if (simbolo==ident) {
      tipoid=busca_tipo_en_tds(id);
      ptrotds= elemtds;
      if (ptrotds!=NULL) {
	camp_aux = ptrotds->lc;
	*tip_izq = ptrotds->tipo;
      }
      if (tipoid==paternvar || tipoid==instancia || tipoid == var) {
	strcpy(ident_accion,id);
      }
      else menerror(49,&error_);
      /* hay que comprobar que su tipo es lista */
    }
    empareja(ident,11, &error_);
    *campos_expr=NULL;

    while (simbolo==punto) {        /* si hay un subcampo se consume */
      obtsym();
      if (simbolo==ident)
	if ((campo=busca_campo(id,camp_aux))!=NULL) {
	  (*campos_expr)=inserta_lista_exp((*campos_expr), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
	  /* despues se inserta en la expresion el campo */
	  (*campos_expr)=inserta_lista_exp((*campos_expr),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);
	  tip_campo = campo->tipo;
	  *tip_izq = tip_campo; //Guardo en tip_izq el tipo de la lista
	  camp_aux = campo->lc;
	  strcpy(campo_accion,id);
	  if (tip_campo!= definido) {
	    if (tip_campo==lista_enteros || tip_campo==lista_reales)
	      strcpy(campo_accion,id);
	    else     /* se esperaba un tipo lista */
	      menerror(93,&error_);
	    if (tip_campo==lista_enteros && tip_expr==real)
	      /* la expresion es de tipo real cuando la
		 lista es de enteros */
	      menerror(3,&error_);
	  }
	}
	else {
	  /*  ese indentificador no es un subcampo de */
	  /* la var patron */
	  menerror(86,&error_);
	}
      empareja(ident,11, &error_);
    }
    empareja(cierrapar,21,&error_);
    if ((tip_expr==err) || error_)
      *tip=err;
    else
      *tip=tip_expr;
    break;

  case addtailsim:
    obtsym();
    *tipoac=oplista_addtail;
    empareja(abrepar,22,&error_);
    *expr_accion = NULL;
    expr_sim(expr_accion,&tip_expr);
    if (tip_expr!=entero && tip_expr!=real) 
      menerror(97,&error_);
    
    if (simbolo == existe) {
      obtsym();
      if (simbolo == ident) {
	tipoid=busca_tipo_en_tds(id);
	if (tipoid != paternvar) {
	  menerror(49,&error_);
	}
      }
    }

    if (simbolo==ident) {
      tipoid=busca_tipo_en_tds(id);
      ptrotds= elemtds;
      if (ptrotds!=NULL) {
	camp_aux = ptrotds->lc;
	*tip_izq = ptrotds->tipo;
      }
      if (tipoid==paternvar || tipoid==instancia || tipoid == var) {
	strcpy(ident_accion,id);
      }
      else
	menerror(49,&error_);
      /* hay que comprobar que su tipo es lista */
    }
    empareja(ident,11, &error_);
    *campos_expr=NULL;
      
    while (simbolo==punto) {        /* si hay un subcampo se consume */
      obtsym();
      if (simbolo==ident)
	if ((campo=busca_campo(id,camp_aux))!=NULL) {
	  (*campos_expr)=inserta_lista_exp((*campos_expr), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
	  /* despues se inserta en la expresion el campo */
	  (*campos_expr)=inserta_lista_exp((*campos_expr),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);
	  tip_campo = campo->tipo;
	  *tip_izq = tip_campo; //Guardo en tip_izq el tipo de la lista
	  camp_aux = campo->lc;
	  strcpy(campo_accion,id);
	  if (tip_campo!= definido) {
	    if (tip_campo==lista_enteros || tip_campo==lista_reales)
	      strcpy(campo_accion,id);
	    else     /* se esperaba un tipo lista */
	      menerror(93,&error_);
	    if (tip_campo==lista_enteros && tip_expr==real)
	      /* la expresion es de tipo real cuando la
		 lista es de enteros */
	      menerror(3,&error_);
	  }
	}
	else {
	  /* ese indentificador no es un subcampo de */
	  /* la var patron */
	  menerror(86,&error_);
	}
      empareja(ident,11, &error_);
    }
    empareja(cierrapar,21,&error_);
    if (tip_expr==err || error_) 
      *tip=err;
    else
      *tip=tip_expr;
    break;

  case haltsim:
               obtsym();
               *tipoac=parada;
               break;
  default:
          /* hace falta tambien una entrada para cuando es una llamada */
          /* pero como tambien empieza por un identificador, hay que usar */
          /* la informacion guardada sobre el identificador para ver si es */
          /* una variable o es una funcion */
          if (simbolo==ident) {
                  tipoid=busca_tipo_en_tds(id);
                  ptrotds= elemtds;
                  if (ptrotds!=NULL) camp_aux=ptrotds->lc;
                  if (tipoid==instancia) {
                           *tipoac=asig_instan;
                           strcpy(ident_accion,id);
                           tip_campo = ptrotds->tipo;
                  } else if (tipoid==paramt) {
                           if (declarando_funcion) {
                                /* debe ser un parametro de la funcion */
                                /* que estamos procesando */
                                if (busca_param(entfuncion->lp,id)!=NULL) {
                                      *tipoac=asig_paramt;
                                      strcpy(ident_accion,id);
                                      tip_campo = ptrotds->tipo;
                                } else  /* error no es un parametro de la funcion */
                                        menerror(100,&error_);
                             } else {
                               /* error no es una funcion lo que estamos declarando */
                               menerror(100,&error_);
                              }
                         } else if (tipoid==var) {
                             *tipoac=asig_var;
                             strcpy(ident_accion,id);
                             tip_campo = ptrotds->tipo;
                         } else 
                            if ((auxfunc=busca_en_funciones(id))!=NULL) {
                              *tipoac = llamada_subprg;
                                 strcpy(ident_accion,id);
                         } else {
                               /* error no es una instancia, ni un parametro */
                               /* ni una funcion */
                               menerror(100,&error_);
                         }
          }
          empareja(ident,11, &error_);
          *campos_expr=NULL;

	  if (*tipoac==asig_instan || *tipoac==asig_paramt || *tipoac==asig_var) {
	    while (simbolo==punto) {        /* si hay un subcampo se consume */
	      obtsym();
	      if (simbolo==ident)
		if ((campo=busca_campo(id,camp_aux))!=NULL) {
		  (*campos_expr)=inserta_lista_exp((*campos_expr), FALSE,FALSE, punto,0,0,NULL,entreal_vacio);
		  /* despues se inserta en la expresion el campo */
		  (*campos_expr)=inserta_lista_exp((*campos_expr),TRUE,TRUE, 0,campo->tipo,paternvar,id,entreal_vacio);

		  strcpy(campo_accion,id);
		  tip_campo = campo->tipo;
		  camp_aux = campo->lc;
		  
		  if (campo->tipo == array) {
		    tip_campo = campo->tbase_array;
		    obtsym();
		    empareja(abrecor, 127, &error_);
		    expr_indice_array = *campos_expr;
		    while (expr_indice_array->sig != NULL) {
		      expr_indice_array = expr_indice_array->sig;
		    }
		    expr_sim(&expr_indice_array->indice_array, &tipo_indice);	
		    switch (tipo_indice) {
		    case entero:
		      break;
		    case definido:
		      expaux = expr_indice_array->indice_array;
		      while (expaux->sig != NULL) {
			expaux = expaux->sig;
		      }
		      if (expaux->tipooperando == entero) {
			tipo_indice = entero;
		      }
		      else {
			menerror(112, &error_);
		      }
		      break;
		    default:
		      menerror(112, &error_);
		      break;
		    }
		    empareja(cierracor, 101, &error_);
		  }
		  else {
		    empareja(ident, 11, &error_);
		  }
		  
		}
		else {
		  /* ese indentificador no es un subcampo de */
		  /* la var patron */
		  menerror(86,&error_);
		}
	      
	      else {
		empareja(ident,11, &error_);
	      }
	      
	    }
	    *tip_izq=tip_campo;
	    if (tip_campo == array) {
	      tip_campo = ptrotds->tbase_array;
	      *tip_izq = ptrotds->tbase_array;
	      empareja (abrecor, 127, &error_);
	      
	      expr_sim(campos_expr, &tipo_indice);
	      if (tipo_indice != entero) {
		menerror(112, &error_);
	      }
	      empareja(cierracor, 101, &error_);
	    }

	    empareja(asigna,14,&error_);
	    lado_izq=NULL;
	    lado_der=NULL;
	    expresion(&oprel,&lado_izq,&lado_der,&tip_expr);
	    *expr_accion=lado_izq;

          /* comprobacion de tipos */
          if (tip_expr!=tip_campo)
               if (tip_expr==entero && tip_campo==real) tip_expr=entero;
                   else if (tip_campo==subrango && tip_expr==entero) {
                           if ((*expr_accion)->esoperando && (*expr_accion)->claseoperando==constante) {
                                /* si se puede se comprueba el rango */
                                if ((*expr_accion)->valor.entero<campo->lim_inf || (*expr_accion)->valor.entero>campo->lim_sup)
                                        menerror(71,&error_);
                                }
                           } else menerror(3,&error_);

          if ((tip_expr==err) || error_) *tip= err;
                                   else  *tip=tip_expr;
        } else if (*tipoac==llamada_subprg) {
           *expr_accion = NULL;
           if (simbolo==abrepar) { /* lleva parametros */
             obtsym();
               lparam = auxfunc->lp;
               num_param= 0;
               do {
                if (lparam==NULL && auxfunc->tipo==interna) {
                   /* no hay mas parametros: numero de parametros incorrecto */
                   menerror(90,&error_);
                } else {
                  expr_sim(expr_accion,&tip_expr);
                  if (auxfunc->tipo==interna) { /* comprobacion de parametros */
                     expaux2=busca_expresion(*expr_accion,num_param);
                     if (lparam->ptro->tipo!=tip_expr) {
                         /* FALTA: la comprobacion de parametros mas a fondo */
                         /* tipo parametro incorrecto */
                         menerror(107,&error_);
                     } else if (tip_expr==definido) /* si los dos son de tipo definido */
                     {
                      /* hay que recorrer la expresion hasta llegar al ultimo nodo */
                      /* que sera el identificador de la instancia de tipo definido */
                      /* si tiene campos */
                         expaux = expaux2;
                         if (!expaux->esoperando && expaux->tipooperador==existe) expaux=expaux->sig;
                         if (expaux->sig!=NULL) {
                            tdsaux = busca_en_tds(expaux->ident);
                            campo = tdsaux->lc;
                            while (expaux->sig!=NULL) {
                                 expaux=expaux->sig;  /* pasamos el punto */
                                 expaux=expaux->sig;
                                 campo=busca_campo(id,campo);
                            }
                            if (strcmp(lparam->ptro->instancia_de,campo->instancia_de))
                            {   /* si no son de la misma clase */
                               menerror(107,&error_);
                            }
                         } else {
                            tdsaux = busca_en_tds(expaux->ident);
                            if (strcmp(lparam->ptro->instancia_de,tdsaux->instancia_de))
                            {   /* si no son de la misma clase */
                              menerror(107,&error_);
                            }
                         }
                     }
                     if (lparam->por_ref && !es_obj_simple(expaux2)) {
                       menerror(109,&error_);
                     }
                     lparam=lparam->sig;
                     num_param++;
                  }
                }
                  /* si se trata de un parametro por referencia y se ha */
                  /* llamado con una expresion que contiene operadores, */
                  /* constantes,etc */
                if(simbolo==coma) {
                     *expr_accion=inserta_lista_exp(*expr_accion,FALSE,FALSE,coma,0,0,NULL,entreal_vacio);
                     obtsym();
                }
               } while (simbolo!=cierrapar && !error_);
               if (lparam!=NULL) {
                   /* faltan parametros : numero de parametros incorrecto */
                   menerror(90,&error_);
               }
             empareja(cierrapar,21,&error_);
           }
        }

   }
}

void lista_exp(//lexp,tip_lista_expr)
	       EXPRESION ** lexp,
	       char *tip_lista_expr) {
  
  char tip_expr;
  int  c;
  
  sincroniza(p_lista_exp,56,s_lista_exp);
  c=0;
  do {
    if(simbolo==coma) {
      obtsym();
      *lexp=inserta_lista_exp(*lexp,FALSE,FALSE,coma,0,0,NULL,entreal_vacio);
    }
    if (simbolo==cadenasim) {
      *lexp=inserta_lista_exp(*lexp,TRUE,FALSE,0,cadena,constante,cadena_comillas,entreal_vacio);
      tip_expr = cadena;
      obtsym();
    } 
    else
      expr_sim(lexp,&tip_expr);
    
    if (c<30) {
      tip_lista_expr[c]=tip_expr;
      c++;
    } 
    else {
      printf("ERROR FATAL: Solo se admiten hasta 30 expresiones en una lista");
      exit(-1);
    }
    if (tip_expr==definido) {
      menerror(107,&tip_expr);
      tip_lista_expr[0]=err;
    } 
    else
      if (tip_expr==err) 
	tip_lista_expr[0]= err;
  } while(simbolo==coma);
}
