/*

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Arlips compiler v. 3.1           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

File tds.h, table of symbols and stuff
April 2006

Copyright (C) 2006 Emilio Vivancos Rubio

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                              Contact                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Author:              Emilio Vivancos Rubio  vivancos@dsic.upv.es
Developer Arlips v2: Mario Gonzlez Gimnez mgonzale@dsic.upv.es
Developer Arlips v3: Carlos Garca Montoro  cargarcia@dsic.upv.es

Departamento de Sistemas Informticos y Computacin
Universidad Politcnica de Valencia
Camino de Vera s/n
46022 Valencia
Spain

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

*/

#ifndef _TDS_
#define _TDS_

#include "constant.h"
#include "tipos.h"

extern int num_maxvp;
extern int numregla;
extern REGFUNC * entfuncion;
extern REGREGLA * entregla;
extern int declarando_funcion;

typedef enum tipoid{entero=1,subrango,definido,real,caracter,boolean,lista_enteros,
		    lista_reales,cadena,err, array, vacio} tipoid;

enum clasobj{var=1,paternvar,inpvar,instancia,paramt,constante,clase,funcion};

enum acciones{asig_patter=1,asig_instan,asig_paramt,asig_var,imprimir,
	      llamada_subprg,retorno_subprg, oplista_addhead,oplista_addtail,
	      parada, log_facts};

enum estategia{profundidad=0, anchura};

enum tiponodo {nodo_and, nodo_or, nodo_condicion, nodo_not};

enum tipofunc {interna,externa};
char * fich_ext[25];
int num_fich_ext;




void procesa_expr_en_accion(REGREGLA *reglita, char *ident, EXPRESION *exp);
void procesa_expr_en_condicion(REGREGLA *regla,
			       EXPRESION *exp,
			       int num_cond, 
			       LISTA_OBJ **lo_cond,
			       int *num_vpe,
			       int *num_vpu,
			       LISTA *lvpeaux,
			       LISTA **param_cond);
int indice_hash();
char repetido_enconst();
char busca_tipo_en_tds();
REGTDS * busca_en_tds();
REGTIPO * busca_en_tipos();
REGREGLA * busca_en_reglas();
REGFUNC * busca_en_funciones();
REGREGLA * busca_regla();
LISTA * cr_lista_id();
LISTA * insertar();
LISTA * insertar_sindup();
LISTA * borrar();
int busca_lista();
EXPRESION * inserta_lista_exp(EXPRESION *le,
			      int esoper,         /* booleano que indica si es un operando */
			      int escamp,         /* booleano que indica si es un campo */
			      char tipop,         /* indica el tipo de operador */
			      char tipoper,       /* indica el tipo de operando */
			      char clasoper,      /* indica la clase del operando */
			      char *ident,        /* identificador del operando */
			      ENTREAL val);
EXPRESION *busca_expresion();
int es_tipo_simple(char simbolo);
int es_obj_simple();
int es_constante();
LISTA_CONDIC * inserta_lista_condic();
LISTA_CONDIC * busca_en_cond();
ARB_COND * crea_nodo_condic();
ARB_COND * inserta_arb_condic_and();
ARB_COND * inserta_arb_condic_or();
void inserta_condac();
LISTA_ACCIONES * inserta_lista_acciones();

LISTA_OBJ * inserta_lista_obj(LISTA_OBJ *lo,
			      char claseobj,                 /* instancia o patternvar */
			      char tipoobj,                 /* tipo del objeto: entero, real, definido */
			      char cuanti,                   /* indica como esta cuantificada */
			      char *superclase,
			      char *nom,
			      int numero_obj,
			      char *campo_obj,
			      LISTA *lcampos);

LISTA_OBJ * busca_obj();
LISTA_PARAM * cr_lista_param();
LISTA_PARAM * insertar_lista_param();
LISTA_PARAM * busca_param();
LISTA * borrar();
struct lipv * crea_lista_inputvar();
LIS_NUM * crea_ln();
LIS_NUM * inserta_ln();
LIS_NUM * borrar_ln();
LISTA_NUM * crea_lista_num();
LISTA_NUM * borrar_lista_num();
void ver_lista_campos();
void ver_lista();
void ver_lista_exp();
void ver_condic();
void ver_condiciones();
void ver_lista_num();
void ver_lista_clases();
LISTA_CAMPOS * crea_lista_campos(LISTA_CAMPOS * l,
				 char * nom,
				 char tip,
				 int linf,
				 int lsup,
				 ENTREAL def,
				 LISTA_NUM *lnum,
				 int tam_lista,
				 char ini,     /* campo que indica si esta inicializado con un valor */
				 char * instancia_de,
				 int t_array);
LISTA_CAMPOS * inserta_lista_campos(LISTA_CAMPOS * l1,  /*lista de campos del registro (se va construyendo)*/
				    LISTA * l2,
				    char tip,
				    int linf,
				    int lsup,
				    ENTREAL def,
				    LISTA_NUM *lnum,
				    int tam_lista,
				    char ini,        /* campo que indica si esta inicializado con un valor */
				    char * instancia_de,
				    int t_array);
LISTA_CAMPOS * busca_campo();
void insertar_en_const();
REGTDS *crea_regtds_simple();
REGTDS *crea_regtds_tipdef();
REGFUNC *insertar_en_func(char nom[long_ident+1],
			  LISTA_PARAM *l_param,
			  /* los siguientes parametros solo tendran valor en llamadas externas */
			  char tipo,
			  char tipo_dev,
			  char * cad_param);
void instipsub_entipos();
void instipsub_entds();
REGTDS * instipdef_entds();
void instipdef_entipos();
void instipreg_entds();
void instipreg_entipos();
REGTDS * instipsimple_entds();
void instipsimple_enclases();
void instipsimple_entipos();
void instipparam_entds();
REGTDS * instiplista_entds();
REGREGLA *  insregla_enreglas();
void ver_listargumentos();
void ver_listaoperaciones();
void ver_tabla_const();
void ver_tabla_func();
void ver_tabla_clases();
void ver_tabla_tds();
void ver_tabla_reglas();
void Procesa_regla();
void Procesa_funcion();
void Detecta_cond_repetidas();
#endif
